var crypto_utils=function(t){"use strict";function e(t){if(!Number.isSafeInteger(t)||t<0)throw new Error(`Wrong positive integer: ${t}`)}function r(t,...e){if(!(t instanceof Uint8Array))throw new TypeError("Expected Uint8Array");if(e.length>0&&!e.includes(t.length))throw new TypeError(`Expected Uint8Array of length ${e}, not of length=${t.length}`)}const n={number:e,bool:function(t){if("boolean"!=typeof t)throw new Error(`Expected boolean, not ${t}`)},bytes:r,hash:function(t){if("function"!=typeof t||"function"!=typeof t.create)throw new Error("Hash should be wrapped by utils.wrapConstructor");e(t.outputLen),e(t.blockLen)},exists:function(t,e=!0){if(t.destroyed)throw new Error("Hash instance has been destroyed");if(e&&t.finished)throw new Error("Hash#digest() has already been called")},output:function(t,e){r(t);const n=e.outputLen;if(t.length<n)throw new Error(`digestInto() expects output buffer of length at least ${n}`)}};var i=n;const o="object"==typeof globalThis&&"crypto"in globalThis?globalThis.crypto:void 0,s=t=>new DataView(t.buffer,t.byteOffset,t.byteLength),f=(t,e)=>t<<32-e|t>>>e;
/*! noble-hashes - MIT License (c) 2022 Paul Miller (paulmillr.com) */if(!(68===new Uint8Array(new Uint32Array([287454020]).buffer)[0]))throw new Error("Non little-endian hardware is not supported");function a(t){if("string"==typeof t&&(t=function(t){if("string"!=typeof t)throw new TypeError("utf8ToBytes expected string, got "+typeof t);return(new TextEncoder).encode(t)}(t)),!(t instanceof Uint8Array))throw new TypeError(`Expected input type is Uint8Array (got ${typeof t})`);return t}Array.from({length:256},((t,e)=>e.toString(16).padStart(2,"0")));let h=class{clone(){return this._cloneInto()}};function c(t){const e=e=>t().update(a(e)).digest(),r=t();return e.outputLen=r.outputLen,e.blockLen=r.blockLen,e.create=()=>t(),e}function u(t=32){if(o&&"function"==typeof o.getRandomValues)return o.getRandomValues(new Uint8Array(t));throw new Error("crypto.getRandomValues must be defined")}let d=class extends h{constructor(t,e,r,n){super(),this.blockLen=t,this.outputLen=e,this.padOffset=r,this.isLE=n,this.finished=!1,this.length=0,this.pos=0,this.destroyed=!1,this.buffer=new Uint8Array(t),this.view=s(this.buffer)}update(t){i.exists(this);const{view:e,buffer:r,blockLen:n}=this,o=(t=a(t)).length;for(let i=0;i<o;){const f=Math.min(n-this.pos,o-i);if(f!==n)r.set(t.subarray(i,i+f),this.pos),this.pos+=f,i+=f,this.pos===n&&(this.process(e,0),this.pos=0);else{const e=s(t);for(;n<=o-i;i+=n)this.process(e,i)}}return this.length+=t.length,this.roundClean(),this}digestInto(t){i.exists(this),i.output(t,this),this.finished=!0;const{buffer:e,view:r,blockLen:n,isLE:o}=this;let{pos:f}=this;e[f++]=128,this.buffer.subarray(f).fill(0),this.padOffset>n-f&&(this.process(r,0),f=0);for(let t=f;t<n;t++)e[t]=0;!function(t,e,r,n){if("function"==typeof t.setBigUint64)return t.setBigUint64(e,r,n);const i=BigInt(32),o=BigInt(4294967295),s=Number(r>>i&o),f=Number(r&o),a=n?4:0,h=n?0:4;t.setUint32(e+a,s,n),t.setUint32(e+h,f,n)}(r,n-8,BigInt(8*this.length),o),this.process(r,0);const a=s(t),h=this.outputLen;if(h%4)throw new Error("_sha2: outputLen should be aligned to 32bit");const c=h/4,u=this.get();if(c>u.length)throw new Error("_sha2: outputLen bigger than state");for(let t=0;t<c;t++)a.setUint32(4*t,u[t],o)}digest(){const{buffer:t,outputLen:e}=this;this.digestInto(t);const r=t.slice(0,e);return this.destroy(),r}_cloneInto(t){t||(t=new this.constructor),t.set(...this.get());const{blockLen:e,buffer:r,length:n,finished:i,destroyed:o,pos:s}=this;return t.length=n,t.pos=s,t.finished=i,t.destroyed=o,n%e&&t.buffer.set(r),t}};const l=(t,e,r)=>t&e^t&r^e&r,g=new Uint32Array([1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298]),p=new Uint32Array([1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225]),w=new Uint32Array(64);let y=class extends d{constructor(){super(64,32,8,!1),this.A=0|p[0],this.B=0|p[1],this.C=0|p[2],this.D=0|p[3],this.E=0|p[4],this.F=0|p[5],this.G=0|p[6],this.H=0|p[7]}get(){const{A:t,B:e,C:r,D:n,E:i,F:o,G:s,H:f}=this;return[t,e,r,n,i,o,s,f]}set(t,e,r,n,i,o,s,f){this.A=0|t,this.B=0|e,this.C=0|r,this.D=0|n,this.E=0|i,this.F=0|o,this.G=0|s,this.H=0|f}process(t,e){for(let r=0;r<16;r++,e+=4)w[r]=t.getUint32(e,!1);for(let t=16;t<64;t++){const e=w[t-15],r=w[t-2],n=f(e,7)^f(e,18)^e>>>3,i=f(r,17)^f(r,19)^r>>>10;w[t]=i+w[t-7]+n+w[t-16]|0}let{A:r,B:n,C:i,D:o,E:s,F:a,G:h,H:c}=this;for(let t=0;t<64;t++){const e=c+(f(s,6)^f(s,11)^f(s,25))+((u=s)&a^~u&h)+g[t]+w[t]|0,d=(f(r,2)^f(r,13)^f(r,22))+l(r,n,i)|0;c=h,h=a,a=s,s=o+e|0,o=i,i=n,n=r,r=e+d|0}var u;r=r+this.A|0,n=n+this.B|0,i=i+this.C|0,o=o+this.D|0,s=s+this.E|0,a=a+this.F|0,h=h+this.G|0,c=c+this.H|0,this.set(r,n,i,o,s,a,h,c)}roundClean(){w.fill(0)}destroy(){this.set(0,0,0,0,0,0,0,0),this.buffer.fill(0)}},b=class extends y{constructor(){super(),this.A=-1056596264,this.B=914150663,this.C=812702999,this.D=-150054599,this.E=-4191439,this.F=1750603025,this.G=1694076839,this.H=-1090891868,this.outputLen=28}};const m=c((()=>new y));c((()=>new b));
/*! noble-curves - MIT License (c) 2022 Paul Miller (paulmillr.com) */
const x=BigInt(0),E=BigInt(1),B=BigInt(2),v=t=>t instanceof Uint8Array,A=Array.from({length:256},((t,e)=>e.toString(16).padStart(2,"0")));function I(t){if(!v(t))throw new Error("Uint8Array expected");let e="";for(let r=0;r<t.length;r++)e+=A[t[r]];return e}function U(t){const e=t.toString(16);return 1&e.length?`0${e}`:e}function S(t){if("string"!=typeof t)throw new Error("hex string expected, got "+typeof t);return BigInt(""===t?"0":`0x${t}`)}function L(t){if("string"!=typeof t)throw new Error("hex string expected, got "+typeof t);if(t.length%2)throw new Error("hex string is invalid: unpadded "+t.length);const e=new Uint8Array(t.length/2);for(let r=0;r<e.length;r++){const n=2*r,i=t.slice(n,n+2),o=Number.parseInt(i,16);if(Number.isNaN(o)||o<0)throw new Error("invalid byte sequence");e[r]=o}return e}function H(t){return S(I(t))}function _(t){if(!v(t))throw new Error("Uint8Array expected");return S(I(Uint8Array.from(t).reverse()))}const $=(t,e)=>L(t.toString(16).padStart(2*e,"0")),O=(t,e)=>$(t,e).reverse();function T(t,e,r){let n;if("string"==typeof e)try{n=L(e)}catch(r){throw new Error(`${t} must be valid hex string, got "${e}". Cause: ${r}`)}else{if(!v(e))throw new Error(`${t} must be hex string or Uint8Array`);n=Uint8Array.from(e)}const i=n.length;if("number"==typeof r&&i!==r)throw new Error(`${t} expected ${r} bytes, got ${i}`);return n}function N(...t){const e=new Uint8Array(t.reduce(((t,e)=>t+e.length),0));let r=0;return t.forEach((t=>{if(!v(t))throw new Error("Uint8Array expected");e.set(t,r),r+=t.length})),e}function R(t){if("string"!=typeof t)throw new Error("utf8ToBytes expected string, got "+typeof t);return(new TextEncoder).encode(t)}const C=t=>(B<<BigInt(t-1))-E,k=t=>new Uint8Array(t),D=t=>Uint8Array.from(t);function F(t,e,r){if("number"!=typeof t||t<2)throw new Error("hashLen must be a number");if("number"!=typeof e||e<2)throw new Error("qByteLen must be a number");if("function"!=typeof r)throw new Error("hmacFn must be a function");let n=k(t),i=k(t),o=0;const s=()=>{n.fill(1),i.fill(0),o=0},f=(...t)=>r(i,n,...t),a=(t=k())=>{i=f(D([0]),t),n=f(),0!==t.length&&(i=f(D([1]),t),n=f())},h=()=>{if(o++>=1e3)throw new Error("drbg: tried 1000 values");let t=0;const r=[];for(;t<e;){n=f();const e=n.slice();r.push(e),t+=n.length}return N(...r)};return(t,e)=>{let r;for(s(),a(t);!(r=e(h()));)a();return s(),r}}const P={bigint:t=>"bigint"==typeof t,function:t=>"function"==typeof t,boolean:t=>"boolean"==typeof t,string:t=>"string"==typeof t,isSafeInteger:t=>Number.isSafeInteger(t),array:t=>Array.isArray(t),field:(t,e)=>e.Fp.isValid(t),hash:t=>"function"==typeof t&&Number.isSafeInteger(t.outputLen)};function q(t,e,r={}){const n=(e,r,n)=>{const i=P[r];if("function"!=typeof i)throw new Error(`Invalid validator "${r}", expected function`);const o=t[e];if(!(n&&void 0===o||i(o,t)))throw new Error(`Invalid param ${String(e)}=${o} (${typeof o}), expected ${r}`)};for(const[t,r]of Object.entries(e))n(t,r,!1);for(const[t,e]of Object.entries(r))n(t,e,!0);return t}var z=Object.freeze({__proto__:null,bitGet:(t,e)=>t>>BigInt(e)&1n,bitLen:function(t){let e;for(e=0;t>0n;t>>=E,e+=1);return e},bitMask:C,bitSet:(t,e,r)=>t|(r?E:x)<<BigInt(e),bytesToHex:I,bytesToNumberBE:H,bytesToNumberLE:_,concatBytes:N,createHmacDrbg:F,ensureBytes:T,equalBytes:function(t,e){if(t.length!==e.length)return!1;for(let r=0;r<t.length;r++)if(t[r]!==e[r])return!1;return!0},hexToBytes:L,hexToNumber:S,numberToBytesBE:$,numberToBytesLE:O,numberToHexUnpadded:U,numberToVarBytesBE:t=>L(U(t)),utf8ToBytes:R,validateObject:q});
/*! noble-curves - MIT License (c) 2022 Paul Miller (paulmillr.com) */const j=BigInt(0),V=BigInt(1),G=BigInt(2),W=BigInt(3),Z=BigInt(4),Y=BigInt(5),K=BigInt(8);function M(t,e){const r=t%e;return r>=j?r:e+r}function J(t,e,r){if(r<=j||e<j)throw new Error("Expected power/modulo > 0");if(r===V)return j;let n=V;for(;e>j;)e&V&&(n=n*t%r),t=t*t%r,e>>=V;return n}function X(t,e,r){let n=t;for(;e-- >j;)n*=n,n%=r;return n}function Q(t,e){if(t===j||e<=j)throw new Error(`invert: expected positive integers, got n=${t} mod=${e}`);let r=M(t,e),n=e,i=j,o=V;for(;r!==j;){const t=n%r,e=i-o*(n/r);n=r,r=t,i=o,o=e}if(n!==V)throw new Error("invert: does not exist");return M(i,e)}function tt(t){if(t%Z===W){const e=(t+V)/Z;return function(t,r){const n=t.pow(r,e);if(!t.eql(t.sqr(n),r))throw new Error("Cannot find square root");return n}}if(t%K===Y){const e=(t-Y)/K;return function(t,r){const n=t.mul(r,G),i=t.pow(n,e),o=t.mul(r,i),s=t.mul(t.mul(o,G),i),f=t.mul(o,t.sub(s,t.ONE));if(!t.eql(t.sqr(f),r))throw new Error("Cannot find square root");return f}}return function(t){const e=(t-V)/G;let r,n,i;for(r=t-V,n=0;r%G===j;r/=G,n++);for(i=G;i<t&&J(i,e,t)!==t-V;i++);if(1===n){const e=(t+V)/Z;return function(t,r){const n=t.pow(r,e);if(!t.eql(t.sqr(n),r))throw new Error("Cannot find square root");return n}}const o=(r+V)/G;return function(t,s){if(t.pow(s,e)===t.neg(t.ONE))throw new Error("Cannot find square root");let f=n,a=t.pow(t.mul(t.ONE,i),r),h=t.pow(s,o),c=t.pow(s,r);for(;!t.eql(c,t.ONE);){if(t.eql(c,t.ZERO))return t.ZERO;let e=1;for(let r=t.sqr(c);e<f&&!t.eql(r,t.ONE);e++)r=t.sqr(r);const r=t.pow(a,V<<BigInt(f-e-1));a=t.sqr(r),h=t.mul(h,r),c=t.mul(c,a),f=e}return h}}(t)}BigInt(9),BigInt(16);const et=["create","isValid","is0","neg","inv","sqrt","sqr","eql","add","sub","mul","pow","div","addN","subN","mulN","sqrN"];function rt(t){return q(t,et.reduce(((t,e)=>(t[e]="function",t)),{ORDER:"bigint",MASK:"bigint",BYTES:"isSafeInteger",BITS:"isSafeInteger"}))}function nt(t,e){const r=void 0!==e?e:t.toString(2).length;return{nBitLength:r,nByteLength:Math.ceil(r/8)}}function it(t,e,r=!1,n={}){if(t<=j)throw new Error(`Expected Fp ORDER > 0, got ${t}`);const{nBitLength:i,nByteLength:o}=nt(t,e);if(o>2048)throw new Error("Field lengths over 2048 bytes are not supported");const s=tt(t),f=Object.freeze({ORDER:t,BITS:i,BYTES:o,MASK:C(i),ZERO:j,ONE:V,create:e=>M(e,t),isValid:e=>{if("bigint"!=typeof e)throw new Error("Invalid field element: expected bigint, got "+typeof e);return j<=e&&e<t},is0:t=>t===j,isOdd:t=>(t&V)===V,neg:e=>M(-e,t),eql:(t,e)=>t===e,sqr:e=>M(e*e,t),add:(e,r)=>M(e+r,t),sub:(e,r)=>M(e-r,t),mul:(e,r)=>M(e*r,t),pow:(t,e)=>function(t,e,r){if(r<j)throw new Error("Expected power > 0");if(r===j)return t.ONE;if(r===V)return e;let n=t.ONE,i=e;for(;r>j;)r&V&&(n=t.mul(n,i)),i=t.sqr(i),r>>=V;return n}(f,t,e),div:(e,r)=>M(e*Q(r,t),t),sqrN:t=>t*t,addN:(t,e)=>t+e,subN:(t,e)=>t-e,mulN:(t,e)=>t*e,inv:e=>Q(e,t),sqrt:n.sqrt||(t=>s(f,t)),invertBatch:t=>function(t,e){const r=new Array(e.length),n=e.reduce(((e,n,i)=>t.is0(n)?e:(r[i]=e,t.mul(e,n))),t.ONE),i=t.inv(n);return e.reduceRight(((e,n,i)=>t.is0(n)?e:(r[i]=t.mul(e,r[i]),t.mul(e,n))),i),r}(f,t),cmov:(t,e,r)=>r?e:t,toBytes:t=>r?O(t,o):$(t,o),fromBytes:t=>{if(t.length!==o)throw new Error(`Fp.fromBytes: expected ${o}, got ${t.length}`);return r?_(t):H(t)}});return Object.freeze(f)}
/*! noble-curves - MIT License (c) 2022 Paul Miller (paulmillr.com) */
const ot=BigInt(0),st=BigInt(1);function ft(t){return rt(t.Fp),q(t,{n:"bigint",h:"bigint",Gx:"field",Gy:"field"},{nBitLength:"isSafeInteger",nByteLength:"isSafeInteger"}),Object.freeze({...nt(t.n,t.nBitLength),...t,p:t.Fp.ORDER})}
/*! noble-curves - MIT License (c) 2022 Paul Miller (paulmillr.com) */const{bytesToNumberBE:at,hexToBytes:ht}=z,ct={Err:class extends Error{constructor(t=""){super(t)}},_parseInt(t){const{Err:e}=ct;if(t.length<2||2!==t[0])throw new e("Invalid signature integer tag");const r=t[1],n=t.subarray(2,r+2);if(!r||n.length!==r)throw new e("Invalid signature integer: wrong length");if(0===n[0]&&n[1]<=127)throw new e("Invalid signature integer: trailing length");return{d:at(n),l:t.subarray(r+2)}},toSig(t){const{Err:e}=ct,r="string"==typeof t?ht(t):t;if(!(r instanceof Uint8Array))throw new Error("ui8a expected");let n=r.length;if(n<2||48!=r[0])throw new e("Invalid signature tag");if(r[1]!==n-2)throw new e("Invalid signature: incorrect length");const{d:i,l:o}=ct._parseInt(r.subarray(2)),{d:s,l:f}=ct._parseInt(o);if(f.length)throw new e("Invalid signature: left bytes after parsing");return{r:i,s:s}},hexFromSig(t){const e=t=>Number.parseInt(t[0],16)>=8?"00"+t:t,r=t=>{const e=t.toString(16);return 1&e.length?`0${e}`:e},n=e(r(t.s)),i=e(r(t.r)),o=n.length/2,s=i.length/2,f=r(o),a=r(s);return`30${r(s+o+4)}02${a}${i}02${f}${n}`}},ut=BigInt(0),dt=BigInt(1),lt=BigInt(2),gt=BigInt(3),pt=BigInt(4);function wt(t){const e=function(t){const e=ft(t);q(e,{a:"field",b:"field"},{allowedPrivateKeyLengths:"array",wrapPrivateKey:"boolean",isTorsionFree:"function",clearCofactor:"function",allowInfinityPoint:"boolean",fromBytes:"function",toBytes:"function"});const{endo:r,Fp:n,a:i}=e;if(r){if(!n.eql(i,n.ZERO))throw new Error("Endomorphism can only be defined for Koblitz curves that have a=0");if("object"!=typeof r||"bigint"!=typeof r.beta||"function"!=typeof r.splitScalar)throw new Error("Expected endomorphism with beta: bigint and splitScalar: function")}return Object.freeze({...e})}(t),{Fp:r}=e,n=e.toBytes||((t,e,n)=>{const i=e.toAffine();return N(Uint8Array.from([4]),r.toBytes(i.x),r.toBytes(i.y))}),i=e.fromBytes||(t=>{const e=t.subarray(1);return{x:r.fromBytes(e.subarray(0,r.BYTES)),y:r.fromBytes(e.subarray(r.BYTES,2*r.BYTES))}});function o(t){const{a:n,b:i}=e,o=r.sqr(t),s=r.mul(o,t);return r.add(r.add(s,r.mul(t,n)),i)}function s(t){return"bigint"==typeof t&&ut<t&&t<e.n}function f(t){if(!s(t))throw new Error("Expected valid bigint: 0 < bigint < curve.n")}function a(t){const{allowedPrivateKeyLengths:r,nByteLength:n,wrapPrivateKey:i,n:o}=e;if(r&&"bigint"!=typeof t){if(t instanceof Uint8Array&&(t=I(t)),"string"!=typeof t||!r.includes(t.length))throw new Error("Invalid key");t=t.padStart(2*n,"0")}let s;try{s="bigint"==typeof t?t:H(T("private key",t,n))}catch(e){throw new Error(`private key must be ${n} bytes, hex or bigint, not ${typeof t}`)}return i&&(s=M(s,o)),f(s),s}const h=new Map;function c(t){if(!(t instanceof u))throw new Error("ProjectivePoint expected")}class u{constructor(t,e,n){if(this.px=t,this.py=e,this.pz=n,null==t||!r.isValid(t))throw new Error("x required");if(null==e||!r.isValid(e))throw new Error("y required");if(null==n||!r.isValid(n))throw new Error("z required")}static fromAffine(t){const{x:e,y:n}=t||{};if(!t||!r.isValid(e)||!r.isValid(n))throw new Error("invalid affine point");if(t instanceof u)throw new Error("projective point not allowed");const i=t=>r.eql(t,r.ZERO);return i(e)&&i(n)?u.ZERO:new u(e,n,r.ONE)}get x(){return this.toAffine().x}get y(){return this.toAffine().y}static normalizeZ(t){const e=r.invertBatch(t.map((t=>t.pz)));return t.map(((t,r)=>t.toAffine(e[r]))).map(u.fromAffine)}static fromHex(t){const e=u.fromAffine(i(T("pointHex",t)));return e.assertValidity(),e}static fromPrivateKey(t){return u.BASE.multiply(a(t))}_setWindowSize(t){this._WINDOW_SIZE=t,h.delete(this)}assertValidity(){if(this.is0()){if(e.allowInfinityPoint)return;throw new Error("bad point: ZERO")}const{x:t,y:n}=this.toAffine();if(!r.isValid(t)||!r.isValid(n))throw new Error("bad point: x or y not FE");const i=r.sqr(n),s=o(t);if(!r.eql(i,s))throw new Error("bad point: equation left != right");if(!this.isTorsionFree())throw new Error("bad point: not in prime-order subgroup")}hasEvenY(){const{y:t}=this.toAffine();if(r.isOdd)return!r.isOdd(t);throw new Error("Field doesn't support isOdd")}equals(t){c(t);const{px:e,py:n,pz:i}=this,{px:o,py:s,pz:f}=t,a=r.eql(r.mul(e,f),r.mul(o,i)),h=r.eql(r.mul(n,f),r.mul(s,i));return a&&h}negate(){return new u(this.px,r.neg(this.py),this.pz)}double(){const{a:t,b:n}=e,i=r.mul(n,gt),{px:o,py:s,pz:f}=this;let a=r.ZERO,h=r.ZERO,c=r.ZERO,d=r.mul(o,o),l=r.mul(s,s),g=r.mul(f,f),p=r.mul(o,s);return p=r.add(p,p),c=r.mul(o,f),c=r.add(c,c),a=r.mul(t,c),h=r.mul(i,g),h=r.add(a,h),a=r.sub(l,h),h=r.add(l,h),h=r.mul(a,h),a=r.mul(p,a),c=r.mul(i,c),g=r.mul(t,g),p=r.sub(d,g),p=r.mul(t,p),p=r.add(p,c),c=r.add(d,d),d=r.add(c,d),d=r.add(d,g),d=r.mul(d,p),h=r.add(h,d),g=r.mul(s,f),g=r.add(g,g),d=r.mul(g,p),a=r.sub(a,d),c=r.mul(g,l),c=r.add(c,c),c=r.add(c,c),new u(a,h,c)}add(t){c(t);const{px:n,py:i,pz:o}=this,{px:s,py:f,pz:a}=t;let h=r.ZERO,d=r.ZERO,l=r.ZERO;const g=e.a,p=r.mul(e.b,gt);let w=r.mul(n,s),y=r.mul(i,f),b=r.mul(o,a),m=r.add(n,i),x=r.add(s,f);m=r.mul(m,x),x=r.add(w,y),m=r.sub(m,x),x=r.add(n,o);let E=r.add(s,a);return x=r.mul(x,E),E=r.add(w,b),x=r.sub(x,E),E=r.add(i,o),h=r.add(f,a),E=r.mul(E,h),h=r.add(y,b),E=r.sub(E,h),l=r.mul(g,x),h=r.mul(p,b),l=r.add(h,l),h=r.sub(y,l),l=r.add(y,l),d=r.mul(h,l),y=r.add(w,w),y=r.add(y,w),b=r.mul(g,b),x=r.mul(p,x),y=r.add(y,b),b=r.sub(w,b),b=r.mul(g,b),x=r.add(x,b),w=r.mul(y,x),d=r.add(d,w),w=r.mul(E,x),h=r.mul(m,h),h=r.sub(h,w),w=r.mul(m,y),l=r.mul(E,l),l=r.add(l,w),new u(h,d,l)}subtract(t){return this.add(t.negate())}is0(){return this.equals(u.ZERO)}wNAF(t){return l.wNAFCached(this,h,t,(t=>{const e=r.invertBatch(t.map((t=>t.pz)));return t.map(((t,r)=>t.toAffine(e[r]))).map(u.fromAffine)}))}multiplyUnsafe(t){const n=u.ZERO;if(t===ut)return n;if(f(t),t===dt)return this;const{endo:i}=e;if(!i)return l.unsafeLadder(this,t);let{k1neg:o,k1:s,k2neg:a,k2:h}=i.splitScalar(t),c=n,d=n,g=this;for(;s>ut||h>ut;)s&dt&&(c=c.add(g)),h&dt&&(d=d.add(g)),g=g.double(),s>>=dt,h>>=dt;return o&&(c=c.negate()),a&&(d=d.negate()),d=new u(r.mul(d.px,i.beta),d.py,d.pz),c.add(d)}multiply(t){f(t);let n,i,o=t;const{endo:s}=e;if(s){const{k1neg:t,k1:e,k2neg:f,k2:a}=s.splitScalar(o);let{p:h,f:c}=this.wNAF(e),{p:d,f:g}=this.wNAF(a);h=l.constTimeNegate(t,h),d=l.constTimeNegate(f,d),d=new u(r.mul(d.px,s.beta),d.py,d.pz),n=h.add(d),i=c.add(g)}else{const{p:t,f:e}=this.wNAF(o);n=t,i=e}return u.normalizeZ([n,i])[0]}multiplyAndAddUnsafe(t,e,r){const n=u.BASE,i=(t,e)=>e!==ut&&e!==dt&&t.equals(n)?t.multiply(e):t.multiplyUnsafe(e),o=i(this,e).add(i(t,r));return o.is0()?void 0:o}toAffine(t){const{px:e,py:n,pz:i}=this,o=this.is0();null==t&&(t=o?r.ONE:r.inv(i));const s=r.mul(e,t),f=r.mul(n,t),a=r.mul(i,t);if(o)return{x:r.ZERO,y:r.ZERO};if(!r.eql(a,r.ONE))throw new Error("invZ was invalid");return{x:s,y:f}}isTorsionFree(){const{h:t,isTorsionFree:r}=e;if(t===dt)return!0;if(r)return r(u,this);throw new Error("isTorsionFree() has not been declared for the elliptic curve")}clearCofactor(){const{h:t,clearCofactor:r}=e;return t===dt?this:r?r(u,this):this.multiplyUnsafe(e.h)}toRawBytes(t=!0){return this.assertValidity(),n(u,this,t)}toHex(t=!0){return I(this.toRawBytes(t))}}u.BASE=new u(e.Gx,e.Gy,r.ONE),u.ZERO=new u(r.ZERO,r.ONE,r.ZERO);const d=e.nBitLength,l=function(t,e){const r=(t,e)=>{const r=e.negate();return t?r:e},n=t=>({windows:Math.ceil(e/t)+1,windowSize:2**(t-1)});return{constTimeNegate:r,unsafeLadder(e,r){let n=t.ZERO,i=e;for(;r>ot;)r&st&&(n=n.add(i)),i=i.double(),r>>=st;return n},precomputeWindow(t,e){const{windows:r,windowSize:i}=n(e),o=[];let s=t,f=s;for(let t=0;t<r;t++){f=s,o.push(f);for(let t=1;t<i;t++)f=f.add(s),o.push(f);s=f.double()}return o},wNAF(e,i,o){const{windows:s,windowSize:f}=n(e);let a=t.ZERO,h=t.BASE;const c=BigInt(2**e-1),u=2**e,d=BigInt(e);for(let t=0;t<s;t++){const e=t*f;let n=Number(o&c);o>>=d,n>f&&(n-=u,o+=st);const s=e,l=e+Math.abs(n)-1,g=t%2!=0,p=n<0;0===n?h=h.add(r(g,i[s])):a=a.add(r(p,i[l]))}return{p:a,f:h}},wNAFCached(t,e,r,n){const i=t._WINDOW_SIZE||1;let o=e.get(t);return o||(o=this.precomputeWindow(t,i),1!==i&&e.set(t,n(o))),this.wNAF(i,o,r)}}}(u,e.endo?Math.ceil(d/2):d);return{CURVE:e,ProjectivePoint:u,normPrivateKeyToScalar:a,weierstrassEquation:o,isWithinCurveOrder:s}}function yt(t){const e=function(t){const e=ft(t);return q(e,{hash:"hash",hmac:"function",randomBytes:"function"},{bits2int:"function",bits2int_modN:"function",lowS:"boolean"}),Object.freeze({lowS:!0,...e})}(t),{Fp:r,n:n}=e,i=r.BYTES+1,o=2*r.BYTES+1;function s(t){return M(t,n)}function f(t){return Q(t,n)}const{ProjectivePoint:a,normPrivateKeyToScalar:h,weierstrassEquation:c,isWithinCurveOrder:u}=wt({...e,toBytes(t,e,n){const i=e.toAffine(),o=r.toBytes(i.x),s=N;return n?s(Uint8Array.from([e.hasEvenY()?2:3]),o):s(Uint8Array.from([4]),o,r.toBytes(i.y))},fromBytes(t){const e=t.length,n=t[0],s=t.subarray(1);if(e!==i||2!==n&&3!==n){if(e===o&&4===n){return{x:r.fromBytes(s.subarray(0,r.BYTES)),y:r.fromBytes(s.subarray(r.BYTES,2*r.BYTES))}}throw new Error(`Point of length ${e} was invalid. Expected ${i} compressed bytes or ${o} uncompressed bytes`)}{const t=H(s);if(!(ut<(f=t)&&f<r.ORDER))throw new Error("Point is not on curve");const e=c(t);let i=r.sqrt(e);return 1==(1&n)!==((i&dt)===dt)&&(i=r.neg(i)),{x:t,y:i}}var f}}),d=t=>I($(t,e.nByteLength));function l(t){return t>n>>dt}const g=(t,e,r)=>H(t.slice(e,r));class p{constructor(t,e,r){this.r=t,this.s=e,this.recovery=r,this.assertValidity()}static fromCompact(t){const r=e.nByteLength;return t=T("compactSignature",t,2*r),new p(g(t,0,r),g(t,r,2*r))}static fromDER(t){const{r:e,s:r}=ct.toSig(T("DER",t));return new p(e,r)}assertValidity(){if(!u(this.r))throw new Error("r must be 0 < r < CURVE.n");if(!u(this.s))throw new Error("s must be 0 < s < CURVE.n")}addRecoveryBit(t){return new p(this.r,this.s,t)}recoverPublicKey(t){const{r:n,s:i,recovery:o}=this,h=m(T("msgHash",t));if(null==o||![0,1,2,3].includes(o))throw new Error("recovery id invalid");const c=2===o||3===o?n+e.n:n;if(c>=r.ORDER)throw new Error("recovery id 2 or 3 invalid");const u=0==(1&o)?"02":"03",l=a.fromHex(u+d(c)),g=f(c),p=s(-h*g),w=s(i*g),y=a.BASE.multiplyAndAddUnsafe(l,p,w);if(!y)throw new Error("point at infinify");return y.assertValidity(),y}hasHighS(){return l(this.s)}normalizeS(){return this.hasHighS()?new p(this.r,s(-this.s),this.recovery):this}toDERRawBytes(){return L(this.toDERHex())}toDERHex(){return ct.hexFromSig({r:this.r,s:this.s})}toCompactRawBytes(){return L(this.toCompactHex())}toCompactHex(){return d(this.r)+d(this.s)}}const w={isValidPrivateKey(t){try{return h(t),!0}catch(t){return!1}},normPrivateKeyToScalar:h,randomPrivateKey:()=>{const t=function(t,e,r=!1){const n=(t=T("privateHash",t)).length,i=nt(e).nByteLength+8;if(i<24||n<i||n>1024)throw new Error(`hashToPrivateScalar: expected ${i}-1024 bytes of input, got ${n}`);return M(r?_(t):H(t),e-V)+V}(e.randomBytes(r.BYTES+8),n);return $(t,e.nByteLength)},precompute:(t=8,e=a.BASE)=>(e._setWindowSize(t),e.multiply(BigInt(3)),e)};function y(t){const e=t instanceof Uint8Array,r="string"==typeof t,n=(e||r)&&t.length;return e?n===i||n===o:r?n===2*i||n===2*o:t instanceof a}const b=e.bits2int||function(t){const r=H(t),n=8*t.length-e.nBitLength;return n>0?r>>BigInt(n):r},m=e.bits2int_modN||function(t){return s(b(t))},x=C(e.nBitLength);function E(t){if("bigint"!=typeof t)throw new Error("bigint expected");if(!(ut<=t&&t<x))throw new Error(`bigint expected < 2^${e.nBitLength}`);return $(t,e.nByteLength)}function B(t,n,i=v){if(["recovered","canonical"].some((t=>t in i)))throw new Error("sign() legacy options not supported");const{hash:o,randomBytes:c}=e;let{lowS:d,prehash:g,extraEntropy:w}=i;null==d&&(d=!0),t=T("msgHash",t),g&&(t=T("prehashed msgHash",o(t)));const y=m(t),x=h(n),B=[E(x),E(y)];if(null!=w){const t=!0===w?c(r.BYTES):w;B.push(T("extraEntropy",t,r.BYTES))}const A=N(...B),I=y;return{seed:A,k2sig:function(t){const e=b(t);if(!u(e))return;const r=f(e),n=a.BASE.multiply(e).toAffine(),i=s(n.x);if(i===ut)return;const o=s(r*s(I+i*x));if(o===ut)return;let h=(n.x===i?0:2)|Number(n.y&dt),c=o;return d&&l(o)&&(c=function(t){return l(t)?s(-t):t}(o),h^=1),new p(i,c,h)}}}const v={lowS:e.lowS,prehash:!1},A={lowS:e.lowS,prehash:!1};return a.BASE._setWindowSize(8),{CURVE:e,getPublicKey:function(t,e=!0){return a.fromPrivateKey(t).toRawBytes(e)},getSharedSecret:function(t,e,r=!0){if(y(t))throw new Error("first arg must be private key");if(!y(e))throw new Error("second arg must be public key");return a.fromHex(e).multiply(h(t)).toRawBytes(r)},sign:function(t,r,n=v){const{seed:i,k2sig:o}=B(t,r,n);return F(e.hash.outputLen,e.nByteLength,e.hmac)(i,o)},verify:function(t,r,n,i=A){const o=t;if(r=T("msgHash",r),n=T("publicKey",n),"strict"in i)throw new Error("options.strict was renamed to lowS");const{lowS:h,prehash:c}=i;let u,d;try{if("string"==typeof o||o instanceof Uint8Array)try{u=p.fromDER(o)}catch(t){if(!(t instanceof ct.Err))throw t;u=p.fromCompact(o)}else{if("object"!=typeof o||"bigint"!=typeof o.r||"bigint"!=typeof o.s)throw new Error("PARSE");{const{r:t,s:e}=o;u=new p(t,e)}}d=a.fromHex(n)}catch(t){if("PARSE"===t.message)throw new Error("signature must be Signature instance, Uint8Array or hex string");return!1}if(h&&u.hasHighS())return!1;c&&(r=e.hash(r));const{r:l,s:g}=u,w=m(r),y=f(g),b=s(w*y),x=s(l*y),E=a.BASE.multiplyAndAddUnsafe(d,b,x)?.toAffine();return!!E&&s(E.x)===l},ProjectivePoint:a,Signature:p,utils:w}}let bt=class extends h{constructor(t,e){super(),this.finished=!1,this.destroyed=!1,i.hash(t);const r=a(e);if(this.iHash=t.create(),"function"!=typeof this.iHash.update)throw new TypeError("Expected instance of class which extends utils.Hash");this.blockLen=this.iHash.blockLen,this.outputLen=this.iHash.outputLen;const n=this.blockLen,o=new Uint8Array(n);o.set(r.length>n?t.create().update(r).digest():r);for(let t=0;t<o.length;t++)o[t]^=54;this.iHash.update(o),this.oHash=t.create();for(let t=0;t<o.length;t++)o[t]^=106;this.oHash.update(o),o.fill(0)}update(t){return i.exists(this),this.iHash.update(t),this}digestInto(t){i.exists(this),i.bytes(t,this.outputLen),this.finished=!0,this.iHash.digestInto(t),this.oHash.update(t),this.oHash.digestInto(t),this.destroy()}digest(){const t=new Uint8Array(this.oHash.outputLen);return this.digestInto(t),t}_cloneInto(t){t||(t=Object.create(Object.getPrototypeOf(this),{}));const{oHash:e,iHash:r,finished:n,destroyed:i,blockLen:o,outputLen:s}=this;return t.finished=n,t.destroyed=i,t.blockLen=o,t.outputLen=s,t.oHash=e._cloneInto(t.oHash),t.iHash=r._cloneInto(t.iHash),t}destroy(){this.destroyed=!0,this.oHash.destroy(),this.iHash.destroy()}};const mt=(t,e,r)=>new bt(t,e).update(r).digest();
/*! noble-curves - MIT License (c) 2022 Paul Miller (paulmillr.com) */
function xt(t){return{hash:t,hmac:(e,...r)=>mt(t,e,function(...t){if(!t.every((t=>t instanceof Uint8Array)))throw new Error("Uint8Array list expected");if(1===t.length)return t[0];const e=t.reduce(((t,e)=>t+e.length),0),r=new Uint8Array(e);for(let e=0,n=0;e<t.length;e++){const i=t[e];r.set(i,n),n+=i.length}return r}(...r)),randomBytes:u}}mt.create=(t,e)=>new bt(t,e);
/*! noble-curves - MIT License (c) 2022 Paul Miller (paulmillr.com) */
const Et=BigInt("0xfffffffffffffffffffffffffffffffffffffffffffffffffffffffefffffc2f"),Bt=BigInt("0xfffffffffffffffffffffffffffffffebaaedce6af48a03bbfd25e8cd0364141"),vt=BigInt(1),At=BigInt(2),It=(t,e)=>(t+e/At)/e;function Ut(t){const e=Et,r=BigInt(3),n=BigInt(6),i=BigInt(11),o=BigInt(22),s=BigInt(23),f=BigInt(44),a=BigInt(88),h=t*t*t%e,c=h*h*t%e,u=X(c,r,e)*c%e,d=X(u,r,e)*c%e,l=X(d,At,e)*h%e,g=X(l,i,e)*l%e,p=X(g,o,e)*g%e,w=X(p,f,e)*p%e,y=X(w,a,e)*w%e,b=X(y,f,e)*p%e,m=X(b,r,e)*c%e,x=X(m,s,e)*g%e,E=X(x,n,e)*h%e,B=X(E,At,e);if(!St.eql(St.sqr(B),t))throw new Error("Cannot find square root");return B}const St=it(Et,void 0,void 0,{sqrt:Ut}),Lt=function(t,e){const r=e=>yt({...t,...xt(e)});return Object.freeze({...r(e),create:r})}({a:BigInt(0),b:BigInt(7),Fp:St,n:Bt,Gx:BigInt("55066263022277343669578718895168534326250603453777594175500187360389116729240"),Gy:BigInt("32670510020758816978083085130507043184471273380659243275938904335757337482424"),h:BigInt(1),lowS:!0,endo:{beta:BigInt("0x7ae96a2b657c07106e64479eac3434e99cf0497512f58995c1396c28719501ee"),splitScalar:t=>{const e=Bt,r=BigInt("0x3086d221a7d46bcde86c90e49284eb15"),n=-vt*BigInt("0xe4437ed6010e88286f547fa90abfe4c3"),i=BigInt("0x114ca50f7a8e2f3f657c1108d9d44cfd8"),o=r,s=BigInt("0x100000000000000000000000000000000"),f=It(o*t,e),a=It(-n*t,e);let h=M(t-f*r-a*i,e),c=M(-f*n-a*o,e);const u=h>s,d=c>s;if(u&&(h=e-h),d&&(c=e-c),h>s||c>s)throw new Error("splitScalar: Endomorphism failed, k="+t);return{k1neg:u,k1:h,k2neg:d,k2:c}}}},m),Ht=BigInt(0),_t=t=>"bigint"==typeof t&&Ht<t&&t<Et,$t=t=>"bigint"==typeof t&&Ht<t&&t<Bt,Ot={};function Tt(t,...e){let r=Ot[t];if(void 0===r){const e=m(Uint8Array.from(t,(t=>t.charCodeAt(0))));r=N(e,e),Ot[t]=r}return m(N(r,...e))}const Nt=t=>t.toRawBytes(!0).slice(1),Rt=t=>$(t,32),Ct=t=>M(t,Et),kt=t=>M(t,Bt),Dt=Lt.ProjectivePoint,Ft=(t,e,r)=>Dt.BASE.multiplyAndAddUnsafe(t,e,r);function Pt(t){let e=Lt.utils.normPrivateKeyToScalar(t),r=Dt.fromPrivateKey(e);return{scalar:r.hasEvenY()?e:kt(-e),bytes:Nt(r)}}function qt(t){if(!_t(t))throw new Error("bad x: need 0 < x < p");const e=Ct(t*t);let r=Ut(Ct(e*t+BigInt(7)));r%At!==Ht&&(r=Ct(-r));const n=new Dt(t,r,vt);return n.assertValidity(),n}function zt(...t){return kt(H(Tt("BIP0340/challenge",...t)))}function jt(t,e,r){const n=T("signature",t,64),i=T("message",e),o=T("publicKey",r,32);try{const t=qt(H(o)),e=H(n.subarray(0,32));if(!_t(e))return!1;const r=H(n.subarray(32,64));if(!$t(r))return!1;const s=zt(Rt(e),Nt(t),i),f=Ft(t,r,kt(-s));return!(!f||!f.hasEvenY()||f.toAffine().x!==e)}catch(t){return!1}}const Vt={getPublicKey:function(t){return Pt(t).bytes},sign:function(t,e,r=u(32)){const n=T("message",t),{bytes:i,scalar:o}=Pt(e),s=T("auxRand",r,32),f=Rt(o^H(Tt("BIP0340/aux",s))),a=Tt("BIP0340/nonce",f,i,n),h=kt(H(a));if(h===Ht)throw new Error("sign failed: k is zero");const{bytes:c,scalar:d}=Pt(h),l=zt(c,i,n),g=new Uint8Array(64);if(g.set(c,0),g.set(Rt(kt(d+l*o)),32),!jt(g,n,i))throw new Error("sign: Invalid signature produced");return g},verify:jt,utils:{randomPrivateKey:Lt.utils.randomPrivateKey,lift_x:qt,pointToBytes:Nt,numberToBytesBE:$,bytesToNumberBE:H,taggedHash:Tt,mod:M}},Gt=function(t,e){const r=e.map((t=>Array.from(t).reverse()));return(e,n)=>{const[i,o,s,f]=r.map((r=>r.reduce(((r,n)=>t.add(t.mul(r,e),n)))));return e=t.div(i,o),n=t.mul(n,t.div(s,f)),{x:e,y:n}}}(St,[["0x8e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38daaaaa8c7","0x7d3d4c80bc321d5b9f315cea7fd44c5d595d2fc0bf63b92dfff1044f17c6581","0x534c328d23f234e6e2a413deca25caece4506144037c40314ecbd0b53d9dd262","0x8e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38e38daaaaa88c"],["0xd35771193d94918a9ca34ccbb7b640dd86cd409542f8487d9fe6b745781eb49b","0xedadc6f64383dc1df7c4b2d51b54225406d36b641f5e41bbc52a56612a8c6d14","0x0000000000000000000000000000000000000000000000000000000000000001"],["0x4bda12f684bda12f684bda12f684bda12f684bda12f684bda12f684b8e38e23c","0xc75e0c32d5cb7c0fa9d0a54b12a0a6d5647ab046d686da6fdffc90fc201d71a3","0x29a6194691f91a73715209ef6512e576722830a201be2018a765e85a9ecee931","0x2f684bda12f684bda12f684bda12f684bda12f684bda12f684bda12f38e38d84"],["0xfffffffffffffffffffffffffffffffffffffffffffffffffffffffefffff93b","0x7a06534bb8bdb49fd5e9e6632722c2989467c1bfc8e8d978dfb425d2685c2573","0x6484aa716545ca2cf3a70c3fa8fe337e0a3d21162f0d6299a7bf8192bfd2a76f","0x0000000000000000000000000000000000000000000000000000000000000001"]].map((t=>t.map((t=>BigInt(t)))))),Wt=function(t,e){if(rt(t),!t.isValid(e.A)||!t.isValid(e.B)||!t.isValid(e.Z))throw new Error("mapToCurveSimpleSWU: invalid opts");const r=function(t,e){const r=t.ORDER;let n=ut;for(let t=r-dt;t%lt===ut;t/=lt)n+=dt;const i=n,o=(r-dt)/lt**i,s=(o-dt)/lt,f=lt**i-dt,a=lt**(i-dt),h=t.pow(e,o),c=t.pow(e,(o+dt)/lt);let u=(e,r)=>{let n=h,o=t.pow(r,f),u=t.sqr(o);u=t.mul(u,r);let d=t.mul(e,u);d=t.pow(d,s),d=t.mul(d,o),o=t.mul(d,r),u=t.mul(d,e);let l=t.mul(u,o);d=t.pow(l,a);let g=t.eql(d,t.ONE);o=t.mul(u,c),d=t.mul(l,n),u=t.cmov(o,u,g),l=t.cmov(d,l,g);for(let e=i;e>1;e--){let r=lt**(e-lt),i=t.pow(l,r);const s=t.eql(i,t.ONE);o=t.mul(u,n),n=t.mul(n,n),i=t.mul(l,n),u=t.cmov(o,u,s),l=t.cmov(i,l,s)}return{isValid:g,value:u}};if(t.ORDER%pt===gt){const r=(t.ORDER-gt)/pt,n=t.sqrt(t.neg(e));u=(e,i)=>{let o=t.sqr(i);const s=t.mul(e,i);o=t.mul(o,s);let f=t.pow(o,r);f=t.mul(f,s);const a=t.mul(f,n),h=t.mul(t.sqr(f),i),c=t.eql(h,e);return{isValid:c,value:t.cmov(a,f,c)}}}return u}(t,e.Z);if(!t.isOdd)throw new Error("Fp.isOdd is not implemented!");return n=>{let i,o,s,f,a,h,c,u;i=t.sqr(n),i=t.mul(i,e.Z),o=t.sqr(i),o=t.add(o,i),s=t.add(o,t.ONE),s=t.mul(s,e.B),f=t.cmov(e.Z,t.neg(o),!t.eql(o,t.ZERO)),f=t.mul(f,e.A),o=t.sqr(s),h=t.sqr(f),a=t.mul(h,e.A),o=t.add(o,a),o=t.mul(o,s),h=t.mul(h,f),a=t.mul(h,e.B),o=t.add(o,a),c=t.mul(i,s);const{isValid:d,value:l}=r(o,h);u=t.mul(i,n),u=t.mul(u,l),c=t.cmov(c,s,d),u=t.cmov(u,l,d);const g=t.isOdd(n)===t.isOdd(u);return u=t.cmov(t.neg(u),u,g),c=t.div(c,f),{x:c,y:u}}}(St,{A:BigInt("0x3f8731abdd661adca08a5558f0f5d272e953d363cb6f0e5d405447c01a444533"),B:BigInt("1771"),Z:St.create(BigInt("-11"))});function Zt(t){if(!Number.isSafeInteger(t)||t<0)throw new Error(`Wrong positive integer: ${t}`)}function Yt(t,...e){if(!(t instanceof Uint8Array))throw new TypeError("Expected Uint8Array");if(e.length>0&&!e.includes(t.length))throw new TypeError(`Expected Uint8Array of length ${e}, not of length=${t.length}`)}!function(t,e,r){if("function"!=typeof e)throw new Error("mapToCurve() must be defined")}(Lt.ProjectivePoint,(t=>{const{x:e,y:r}=Wt(St.create(t[0]));return Gt(e,r)}),{DST:"secp256k1_XMD:SHA-256_SSWU_RO_",encodeDST:"secp256k1_XMD:SHA-256_SSWU_NU_",p:St.ORDER,m:1,k:128,expand:"xmd",hash:m});const Kt={number:Zt,bool:function(t){if("boolean"!=typeof t)throw new Error(`Expected boolean, not ${t}`)},bytes:Yt,hash:function(t){if("function"!=typeof t||"function"!=typeof t.create)throw new Error("Hash should be wrapped by utils.wrapConstructor");Zt(t.outputLen),Zt(t.blockLen)},exists:function(t,e=!0){if(t.destroyed)throw new Error("Hash instance has been destroyed");if(e&&t.finished)throw new Error("Hash#digest() has already been called")},output:function(t,e){Yt(t);const r=e.outputLen;if(t.length<r)throw new Error(`digestInto() expects output buffer of length at least ${r}`)}};var Mt=Kt;
/*! noble-hashes - MIT License (c) 2022 Paul Miller (paulmillr.com) */const Jt=t=>new DataView(t.buffer,t.byteOffset,t.byteLength),Xt=(t,e)=>t<<32-e|t>>>e;if(!(68===new Uint8Array(new Uint32Array([287454020]).buffer)[0]))throw new Error("Non little-endian hardware is not supported");function Qt(t){if("string"==typeof t&&(t=function(t){if("string"!=typeof t)throw new TypeError("utf8ToBytes expected string, got "+typeof t);return(new TextEncoder).encode(t)}(t)),!(t instanceof Uint8Array))throw new TypeError(`Expected input type is Uint8Array (got ${typeof t})`);return t}Array.from({length:256},((t,e)=>e.toString(16).padStart(2,"0")));let te=class{clone(){return this._cloneInto()}};function ee(t){const e=e=>t().update(Qt(e)).digest(),r=t();return e.outputLen=r.outputLen,e.blockLen=r.blockLen,e.create=()=>t(),e}let re=class extends te{constructor(t,e,r,n){super(),this.blockLen=t,this.outputLen=e,this.padOffset=r,this.isLE=n,this.finished=!1,this.length=0,this.pos=0,this.destroyed=!1,this.buffer=new Uint8Array(t),this.view=Jt(this.buffer)}update(t){Mt.exists(this);const{view:e,buffer:r,blockLen:n}=this,i=(t=Qt(t)).length;for(let o=0;o<i;){const s=Math.min(n-this.pos,i-o);if(s!==n)r.set(t.subarray(o,o+s),this.pos),this.pos+=s,o+=s,this.pos===n&&(this.process(e,0),this.pos=0);else{const e=Jt(t);for(;n<=i-o;o+=n)this.process(e,o)}}return this.length+=t.length,this.roundClean(),this}digestInto(t){Mt.exists(this),Mt.output(t,this),this.finished=!0;const{buffer:e,view:r,blockLen:n,isLE:i}=this;let{pos:o}=this;e[o++]=128,this.buffer.subarray(o).fill(0),this.padOffset>n-o&&(this.process(r,0),o=0);for(let t=o;t<n;t++)e[t]=0;!function(t,e,r,n){if("function"==typeof t.setBigUint64)return t.setBigUint64(e,r,n);const i=BigInt(32),o=BigInt(4294967295),s=Number(r>>i&o),f=Number(r&o),a=n?4:0,h=n?0:4;t.setUint32(e+a,s,n),t.setUint32(e+h,f,n)}(r,n-8,BigInt(8*this.length),i),this.process(r,0);const s=Jt(t),f=this.outputLen;if(f%4)throw new Error("_sha2: outputLen should be aligned to 32bit");const a=f/4,h=this.get();if(a>h.length)throw new Error("_sha2: outputLen bigger than state");for(let t=0;t<a;t++)s.setUint32(4*t,h[t],i)}digest(){const{buffer:t,outputLen:e}=this;this.digestInto(t);const r=t.slice(0,e);return this.destroy(),r}_cloneInto(t){t||(t=new this.constructor),t.set(...this.get());const{blockLen:e,buffer:r,length:n,finished:i,destroyed:o,pos:s}=this;return t.length=n,t.pos=s,t.finished=i,t.destroyed=o,n%e&&t.buffer.set(r),t}};const ne=(t,e,r)=>t&e^t&r^e&r,ie=new Uint32Array([1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298]),oe=new Uint32Array([1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225]),se=new Uint32Array(64);let fe=class extends re{constructor(){super(64,32,8,!1),this.A=0|oe[0],this.B=0|oe[1],this.C=0|oe[2],this.D=0|oe[3],this.E=0|oe[4],this.F=0|oe[5],this.G=0|oe[6],this.H=0|oe[7]}get(){const{A:t,B:e,C:r,D:n,E:i,F:o,G:s,H:f}=this;return[t,e,r,n,i,o,s,f]}set(t,e,r,n,i,o,s,f){this.A=0|t,this.B=0|e,this.C=0|r,this.D=0|n,this.E=0|i,this.F=0|o,this.G=0|s,this.H=0|f}process(t,e){for(let r=0;r<16;r++,e+=4)se[r]=t.getUint32(e,!1);for(let t=16;t<64;t++){const e=se[t-15],r=se[t-2],n=Xt(e,7)^Xt(e,18)^e>>>3,i=Xt(r,17)^Xt(r,19)^r>>>10;se[t]=i+se[t-7]+n+se[t-16]|0}let{A:r,B:n,C:i,D:o,E:s,F:f,G:a,H:h}=this;for(let t=0;t<64;t++){const e=h+(Xt(s,6)^Xt(s,11)^Xt(s,25))+((c=s)&f^~c&a)+ie[t]+se[t]|0,u=(Xt(r,2)^Xt(r,13)^Xt(r,22))+ne(r,n,i)|0;h=a,a=f,f=s,s=o+e|0,o=i,i=n,n=r,r=e+u|0}var c;r=r+this.A|0,n=n+this.B|0,i=i+this.C|0,o=o+this.D|0,s=s+this.E|0,f=f+this.F|0,a=a+this.G|0,h=h+this.H|0,this.set(r,n,i,o,s,f,a,h)}roundClean(){se.fill(0)}destroy(){this.set(0,0,0,0,0,0,0,0),this.buffer.fill(0)}},ae=class extends fe{constructor(){super(),this.A=-1056596264,this.B=914150663,this.C=812702999,this.D=-150054599,this.E=-4191439,this.F=1750603025,this.G=1694076839,this.H=-1090891868,this.outputLen=28}};const he=ee((()=>new fe));
/*! scure-base - MIT License (c) 2022 Paul Miller (paulmillr.com) */
function ce(t){if(!Number.isSafeInteger(t))throw new Error(`Wrong integer: ${t}`)}function ue(...t){const e=(t,e)=>r=>t(e(r));return{encode:Array.from(t).reverse().reduce(((t,r)=>t?e(t,r.encode):r.encode),void 0),decode:t.reduce(((t,r)=>t?e(t,r.decode):r.decode),void 0)}}function de(t){return{encode:e=>{if(!Array.isArray(e)||e.length&&"number"!=typeof e[0])throw new Error("alphabet.encode input should be an array of numbers");return e.map((e=>{if(ce(e),e<0||e>=t.length)throw new Error(`Digit index outside alphabet: ${e} (alphabet: ${t.length})`);return t[e]}))},decode:e=>{if(!Array.isArray(e)||e.length&&"string"!=typeof e[0])throw new Error("alphabet.decode input should be array of strings");return e.map((e=>{if("string"!=typeof e)throw new Error(`alphabet.decode: not string element=${e}`);const r=t.indexOf(e);if(-1===r)throw new Error(`Unknown letter: "${e}". Allowed: ${t}`);return r}))}}}function le(t=""){if("string"!=typeof t)throw new Error("join separator should be string");return{encode:e=>{if(!Array.isArray(e)||e.length&&"string"!=typeof e[0])throw new Error("join.encode input should be array of strings");for(let t of e)if("string"!=typeof t)throw new Error(`join.encode: non-string input=${t}`);return e.join(t)},decode:e=>{if("string"!=typeof e)throw new Error("join.decode input should be string");return e.split(t)}}}function ge(t,e="="){if(ce(t),"string"!=typeof e)throw new Error("padding chr should be string");return{encode(r){if(!Array.isArray(r)||r.length&&"string"!=typeof r[0])throw new Error("padding.encode input should be array of strings");for(let t of r)if("string"!=typeof t)throw new Error(`padding.encode: non-string input=${t}`);for(;r.length*t%8;)r.push(e);return r},decode(r){if(!Array.isArray(r)||r.length&&"string"!=typeof r[0])throw new Error("padding.encode input should be array of strings");for(let t of r)if("string"!=typeof t)throw new Error(`padding.decode: non-string input=${t}`);let n=r.length;if(n*t%8)throw new Error("Invalid padding: string should have whole number of bytes");for(;n>0&&r[n-1]===e;n--)if(!((n-1)*t%8))throw new Error("Invalid padding: string has too much padding");return r.slice(0,n)}}}function pe(t){if("function"!=typeof t)throw new Error("normalize fn should be function");return{encode:t=>t,decode:e=>t(e)}}function we(t,e,r){if(e<2)throw new Error(`convertRadix: wrong from=${e}, base cannot be less than 2`);if(r<2)throw new Error(`convertRadix: wrong to=${r}, base cannot be less than 2`);if(!Array.isArray(t))throw new Error("convertRadix: data should be array");if(!t.length)return[];let n=0;const i=[],o=Array.from(t);for(o.forEach((t=>{if(ce(t),t<0||t>=e)throw new Error(`Wrong integer: ${t}`)}));;){let t=0,s=!0;for(let i=n;i<o.length;i++){const f=o[i],a=e*t+f;if(!Number.isSafeInteger(a)||e*t/e!==t||a-f!=e*t)throw new Error("convertRadix: carry overflow");if(t=a%r,o[i]=Math.floor(a/r),!Number.isSafeInteger(o[i])||o[i]*r+t!==a)throw new Error("convertRadix: carry overflow");s&&(o[i]?s=!1:n=i)}if(i.push(t),s)break}for(let e=0;e<t.length-1&&0===t[e];e++)i.push(0);return i.reverse()}ee((()=>new ae));const ye=(t,e)=>e?ye(e,t%e):t,be=(t,e)=>t+(e-ye(t,e));function me(t,e,r,n){if(!Array.isArray(t))throw new Error("convertRadix2: data should be array");if(e<=0||e>32)throw new Error(`convertRadix2: wrong from=${e}`);if(r<=0||r>32)throw new Error(`convertRadix2: wrong to=${r}`);if(be(e,r)>32)throw new Error(`convertRadix2: carry overflow from=${e} to=${r} carryBits=${be(e,r)}`);let i=0,o=0;const s=2**r-1,f=[];for(const n of t){if(ce(n),n>=2**e)throw new Error(`convertRadix2: invalid data word=${n} from=${e}`);if(i=i<<e|n,o+e>32)throw new Error(`convertRadix2: carry overflow pos=${o} from=${e}`);for(o+=e;o>=r;o-=r)f.push((i>>o-r&s)>>>0);i&=2**o-1}if(i=i<<r-o&s,!n&&o>=e)throw new Error("Excess padding");if(!n&&i)throw new Error(`Non-zero padding: ${i}`);return n&&o>0&&f.push(i>>>0),f}function xe(t,e=!1){if(ce(t),t<=0||t>32)throw new Error("radix2: bits should be in (0..32]");if(be(8,t)>32||be(t,8)>32)throw new Error("radix2: carry overflow");return{encode:r=>{if(!(r instanceof Uint8Array))throw new Error("radix2.encode input should be Uint8Array");return me(Array.from(r),8,t,!e)},decode:r=>{if(!Array.isArray(r)||r.length&&"number"!=typeof r[0])throw new Error("radix2.decode input should be array of strings");return Uint8Array.from(me(r,t,8,e))}}}function Ee(t){if("function"!=typeof t)throw new Error("unsafeWrapper fn should be function");return function(...e){try{return t.apply(null,e)}catch(t){}}}const Be=ue(xe(4),de("0123456789ABCDEF"),le("")),ve=ue(xe(5),de("ABCDEFGHIJKLMNOPQRSTUVWXYZ234567"),ge(5),le(""));ue(xe(5),de("0123456789ABCDEFGHIJKLMNOPQRSTUV"),ge(5),le("")),ue(xe(5),de("0123456789ABCDEFGHJKMNPQRSTVWXYZ"),le(""),pe((t=>t.toUpperCase().replace(/O/g,"0").replace(/[IL]/g,"1"))));const Ae=ue(xe(6),de("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"),ge(6),le("")),Ie=ue(xe(6),de("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_"),ge(6),le("")),Ue=t=>{return ue((ce(e=58),{encode:t=>{if(!(t instanceof Uint8Array))throw new Error("radix.encode input should be Uint8Array");return we(Array.from(t),256,e)},decode:t=>{if(!Array.isArray(t)||t.length&&"number"!=typeof t[0])throw new Error("radix.decode input should be array of strings");return Uint8Array.from(we(t,e,256))}}),de(t),le(""));var e},Se=Ue("123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz");Ue("123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ"),Ue("rpshnaf39wBUDNEGHJKLM4PQRST7VWXYZ2bcdeCg65jkm8oFqi1tuvAxyz");const Le=[0,2,3,5,6,7,9,10,11],He={encode(t){let e="";for(let r=0;r<t.length;r+=8){const n=t.subarray(r,r+8);e+=Se.encode(n).padStart(Le[n.length],"1")}return e},decode(t){let e=[];for(let r=0;r<t.length;r+=11){const n=t.slice(r,r+11),i=Le.indexOf(n.length),o=Se.decode(n);for(let t=0;t<o.length-i;t++)if(0!==o[t])throw new Error("base58xmr: wrong padding");e=e.concat(Array.from(o.slice(o.length-i)))}return Uint8Array.from(e)}},_e=t=>ue(function(t,e){if(ce(t),"function"!=typeof e)throw new Error("checksum fn should be function");return{encode(r){if(!(r instanceof Uint8Array))throw new Error("checksum.encode: input should be Uint8Array");const n=e(r).slice(0,t),i=new Uint8Array(r.length+t);return i.set(r),i.set(n,r.length),i},decode(r){if(!(r instanceof Uint8Array))throw new Error("checksum.decode: input should be Uint8Array");const n=r.slice(0,-t),i=e(n).slice(0,t),o=r.slice(-t);for(let e=0;e<t;e++)if(i[e]!==o[e])throw new Error("Invalid checksum");return n}}}(4,(e=>t(t(e)))),Se),$e=ue(de("qpzry9x8gf2tvdw0s3jn54khce6mua7l"),le("")),Oe=[996825010,642813549,513874426,1027748829,705979059];function Te(t){const e=t>>25;let r=(33554431&t)<<5;for(let t=0;t<Oe.length;t++)1==(e>>t&1)&&(r^=Oe[t]);return r}function Ne(t,e,r=1){const n=t.length;let i=1;for(let e=0;e<n;e++){const r=t.charCodeAt(e);if(r<33||r>126)throw new Error(`Invalid prefix (${t})`);i=Te(i)^r>>5}i=Te(i);for(let e=0;e<n;e++)i=Te(i)^31&t.charCodeAt(e);for(let t of e)i=Te(i)^t;for(let t=0;t<6;t++)i=Te(i);return i^=r,$e.encode(me([i%2**30],30,5,!1))}function Re(t){const e="bech32"===t?1:734539939,r=xe(5),n=r.decode,i=r.encode,o=Ee(n);function s(t,r=90){if("string"!=typeof t)throw new Error("bech32.decode input should be string, not "+typeof t);if(t.length<8||!1!==r&&t.length>r)throw new TypeError(`Wrong string length: ${t.length} (${t}). Expected (8..${r})`);const n=t.toLowerCase();if(t!==n&&t!==t.toUpperCase())throw new Error("String must be lowercase or uppercase");const i=(t=n).lastIndexOf("1");if(0===i||-1===i)throw new Error('Letter "1" must be present between prefix and data only');const o=t.slice(0,i),s=t.slice(i+1);if(s.length<6)throw new Error("Data must be at least 6 characters long");const f=$e.decode(s).slice(0,-6),a=Ne(o,f,e);if(!s.endsWith(a))throw new Error(`Invalid checksum in ${t}: expected "${a}"`);return{prefix:o,words:f}}return{encode:function(t,r,n=90){if("string"!=typeof t)throw new Error("bech32.encode prefix should be string, not "+typeof t);if(!Array.isArray(r)||r.length&&"number"!=typeof r[0])throw new Error("bech32.encode words should be array of numbers, not "+typeof r);const i=t.length+7+r.length;if(!1!==n&&i>n)throw new TypeError(`Length ${i} exceeds limit ${n}`);return`${t=t.toLowerCase()}1${$e.encode(r)}${Ne(t,r,e)}`},decode:s,decodeToBytes:function(t){const{prefix:e,words:r}=s(t,!1);return{prefix:e,words:r,bytes:n(r)}},decodeUnsafe:Ee(s),fromWords:n,fromWordsUnsafe:o,toWords:i}}const Ce=Re("bech32"),ke=Re("bech32m"),De={utf8:{encode:t=>(new TextDecoder).decode(t),decode:t=>(new TextEncoder).encode(t)},hex:ue(xe(4),de("0123456789abcdef"),le(""),pe((t=>{if("string"!=typeof t||t.length%2)throw new TypeError(`hex.decode: expected string, got ${typeof t} with length ${t.length}`);return t.toLowerCase()}))),base16:Be,base32:ve,base64:Ae,base64url:Ie,base58:Se,base58xmr:He};Object.keys(De).join(", ");const Fe={encode:t=>_e(he).encode(t),decode:t=>_e(he).decode(t)},Pe={encode:t=>Ae.encode(t),decode:t=>Ae.decode(t)},qe={encode:t=>Ie.encode(t),decode:t=>Ie.decode(t)},ze={into_words:Ce.toWords,from_words:Ce.fromWords,encode:(t,e,r=!1)=>Ce.encode(t,Ce.toWords(e),r),decode:(t,e=!1)=>{const{prefix:r,words:n}=Ce.decode(t,e);return{prefix:r,words:n,bytes:Ce.fromWords(n)}}},je={into_words:ke.toWords,from_words:ke.fromWords,encode:(t,e,r=!1)=>ke.encode(t,ke.toWords(e),r),decode:(t,e=!1)=>{const{prefix:r,words:n}=ke.decode(t,e);return{prefix:r,words:n,bytes:ke.fromWords(n)}}};function Ve(t){if(t>Number.MAX_SAFE_INTEGER)throw new TypeError("Number exceeds safe bounds!")}function Ge(t,e){if(t!==e)throw new TypeError(`Bech32 prefix does not match: ${t} !== ${e}`)}const We=BigInt(0),Ze=BigInt(255),Ye=BigInt(256);function Ke(t,e,r="be"){void 0===e&&(e=function(t){if(t<=0xffn)return 1;if(t<=0xffffn)return 2;if(t<=0xffffffffn)return 4;if(t<=0xffffffffffffffffn)return 8;if(t<=0xffffffffffffffffffffffffffffffffn)return 16;if(t<=0xffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffn)return 32;throw new TypeError("Must specify a fixed buffer size for bigints greater than 32 bytes.")}(t));const n="le"===r,i=new ArrayBuffer(e),o=new DataView(i);let s=n?0:e-1;for(;t>We;){const e=t&Ze,r=Number(e);n?o.setUint8(s++,r):o.setUint8(s--,r),t=(t-e)/Ye}return new Uint8Array(i)}function Me(t,e,r="be"){void 0===e&&(e=function(t){if(t<=255)return 1;if(t<=65535)return 2;if(t<=4294967295)return 4;throw new TypeError("Numbers larger than 4 bytes must specify a fixed size!")}(t));const n="le"===r,i=new ArrayBuffer(e),o=new DataView(i);let s=n?0:e-1;for(;t>0;){const e=255&t;n?o.setUint8(s++,t):o.setUint8(s--,t),t=(t-e)/256}return new Uint8Array(i)}const Je=new TextEncoder,Xe=new TextDecoder;function Qe(t){return Je.encode(t)}function tr(t){return Xe.decode(t)}function er(t,e){!function(t){if(null!==t.match(/[^a-fA-f0-9]/))throw new TypeError("Invalid characters in hex string: "+t);if(t.length%2!=0)throw new Error(`Length of hex string is invalid: ${t.length}`)}(t);const r=t.length/2;if(void 0===e&&(e=r),r>e)throw new TypeError(`Hex string is larger than array size: ${r} > ${e}`);return e}const{getRandomValues:rr}=crypto??globalThis.crypto??window.crypto;function nr(t,e,r="be"){void 0===e&&(e=t.length),function(t,e){if(t.length>e)throw new TypeError(`Data is larger than array size: ${t.length} > ${e}`)}(t,e);const n=new Uint8Array(e).fill(0),i="be"===r?0:e-t.length;return n.set(t,i),n}function ir(t){let e,r=0;const n=t.reduce(((t,e)=>t+e.length),0),i=new Uint8Array(n);for(e=0;e<t.length;e++){const n=t[e];i.set(n,r),r+=n.length}return i}function or(t,e){return"bigint"==typeof e?`${e}n`:e}function sr(t,e){return"string"==typeof e&&/n$/.test(e)?BigInt(e.slice(0,-1)):e}function fr(t,e,r){if(t instanceof ArrayBuffer)return new Uint8Array(t);if(t instanceof Uint8Array)return nr(t,e,r);if(Array.isArray(t))try{return ir(t.map((t=>fr(t,e,r))))}catch(t){const{message:e}=t;throw new TypeError("Invalid data caught in array."+e)}if("string"==typeof t)return function(t,e,r="le"){e=er(t,e);const n="le"===r,i=new ArrayBuffer(e),o=new DataView(i);let s=n?0:e-1;for(let e=0;e<t.length;e+=2){const r=t.substring(e,e+2),i=parseInt(r,16);n?o.setUint8(s++,i):o.setUint8(s--,i)}return new Uint8Array(i)}(t,e,r);if("bigint"==typeof t)return Ke(t,e,r);if("number"==typeof t)return Me(t,e,r);if("boolean"==typeof t)return Uint8Array.of(t?1:0);throw new TypeError("Unsupported format:"+String(typeof t))}class ar extends Uint8Array{static{this.num=hr}static{this.big=ur}static{this.bin=cr}static{this.raw=dr}static{this.str=lr}static{this.hex=gr}static{this.bytes=Br}static{this.json=pr}static{this.base64=wr}static{this.b64url=yr}static{this.bech32=br}static{this.bech32m=mr}static{this.b58chk=xr}static{this.encode=Qe}static{this.decode=tr}static random(t=32){const e=function(t=32){if("function"==typeof rr)return crypto.getRandomValues(new Uint8Array(t));throw new Error("Crypto module missing getRandomValues!")}(t);return new ar(e,t)}constructor(t,e,r){if(t instanceof ar&&void 0===e)return t;super(fr(t,e,r))}get arr(){return[...this]}get num(){return this.toNum()}get big(){return this.toBig()}get str(){return this.toStr()}get hex(){return this.toHex()}get raw(){return new Uint8Array(this)}get bin(){return this.toBin()}get b58chk(){return this.tob58chk()}get base64(){return this.toBase64()}get b64url(){return this.toB64url()}get digest(){return this.toHash()}get id(){return this.toHash().hex}get stream(){return new Er(this)}toNum(t="be"){return function(t){let e=0;for(let r=t.length-1;r>=0;r--)e=256*e+t[r],Ve(e);return e}("be"===t?this.reverse():this)}toBig(t="be"){return function(t){let e=BigInt(0);for(let r=t.length-1;r>=0;r--)e=e*Ye+BigInt(t[r]);return BigInt(e)}("be"===t?this.reverse():this)}toBin(){return function(t){const e=new Array(8*t.length);let r=0;for(const n of t){if(n>255)throw new Error(`Invalid byte value: ${n}. Byte values must be between 0 and 255.`);for(let t=7;t>=0;t--,r++)e[r]=n>>t&1}return e.join("")}(this)}toHash(){const t=he(this);return new ar(t)}toJson(t){void 0===t&&(t=sr);const e=tr(this);return JSON.parse(e,t)}toBech32(t,e){return ze.encode(t,this,e)}toBech32m(t,e){return je.encode(t,this,e)}toStr(){return tr(this)}toHex(){return function(t){let e="";for(let r=0;r<t.length;r++)e+=t[r].toString(16).padStart(2,"0");return e}(this)}toBytes(){return new Uint8Array(this)}tob58chk(){return Fe.encode(this)}toBase64(){return Pe.encode(this)}toB64url(){return qe.encode(this)}append(t){return ar.join([this,ar.bytes(t)])}prepend(t){return ar.join([ar.bytes(t),this])}reverse(){const t=new Uint8Array(this).reverse();return new ar(t)}slice(t,e){const r=new Uint8Array(this).slice(t,e);return new ar(r)}set(t,e){this.set(t,e)}subarray(t,e){const r=new Uint8Array(this).subarray(t,e);return new ar(r)}write(t,e){const r=ar.bytes(t);this.set(r,e)}prefixSize(t){const e=ar.varInt(this.length,t);return ar.join([e,this])}static from(t){return new ar(Uint8Array.from(t))}static of(...t){return new ar(Uint8Array.of(...t))}static join(t){const e=ir(t.map((t=>ar.bytes(t))));return new ar(e)}static sort(t,e){const r=t.map((t=>Br(t,e).hex));return r.sort(),r.map((t=>ar.hex(t,e)))}static varInt(t,e){if(t<253)return ar.num(t,1);if(t<65536)return ar.of(253,...ar.num(t,2,e));if(t<4294967296)return ar.of(254,...ar.num(t,4,e));if(BigInt(t)<0x10000000000000000n)return ar.of(255,...ar.num(t,8,e));throw new Error(`Value is too large: ${t}`)}}function hr(t,e,r){return new ar(t,e,r)}function cr(t,e,r){return new ar(function(t){const e=t.split("").map(Number);if(e.length%8!=0)throw new Error(`Binary array is invalid length: ${t.length}`);const r=new Uint8Array(e.length/8);for(let t=0,n=0;t<e.length;t+=8,n++){let i=0;for(let r=0;r<8;r++)i|=e[t+r]<<7-r;r[n]=i}return r}(t),e,r)}function ur(t,e,r){return new ar(t,e,r)}function dr(t,e,r){return new ar(t,e,r)}function lr(t,e,r){return new ar(Qe(t),e,r)}function gr(t,e,r){return new ar(t,e,r)}function pr(t,e){void 0===e&&(e=or);const r=JSON.stringify(t,e);return new ar(Qe(r))}function wr(t){return new ar(Pe.decode(t))}function yr(t){return new ar(qe.decode(t))}function br(t,e,r){const{bytes:n,prefix:i}=ze.decode(t,e);return"string"==typeof r&&Ge(i,r),new ar(n)}function mr(t,e,r){const{bytes:n,prefix:i}=je.decode(t,e);return"string"==typeof r&&Ge(i,r),new ar(n)}function xr(t){return new ar(Fe.decode(t))}class Er{constructor(t){this.data=ar.bytes(t),this.size=this.data.length}peek(t){if(t>this.size)throw new Error(`Size greater than stream: ${t} > ${this.size}`);return new ar(this.data.slice(0,t))}read(t){t=t??this.readSize();const e=this.peek(t);return this.data=this.data.slice(t),this.size=this.data.length,e}readSize(t){const e=this.read(1).num;switch(!0){case e>=0&&e<253:return e;case 253===e:return this.read(2).toNum(t);case 254===e:return this.read(4).toNum(t);case 255===e:return this.read(8).toNum(t);default:throw new Error(`Varint is out of range: ${e}`)}}}function Br(t,e,r){return new ar(t,e,r)}function vr(t){if(!Number.isSafeInteger(t)||t<0)throw new Error(`Wrong positive integer: ${t}`)}function Ar(t,...e){if(!(t instanceof Uint8Array))throw new Error("Expected Uint8Array");if(e.length>0&&!e.includes(t.length))throw new Error(`Expected Uint8Array of length ${e}, not of length=${t.length}`)}const Ir={number:vr,bool:function(t){if("boolean"!=typeof t)throw new Error(`Expected boolean, not ${t}`)},bytes:Ar,hash:function(t){if("function"!=typeof t||"function"!=typeof t.create)throw new Error("Hash should be wrapped by utils.wrapConstructor");vr(t.outputLen),vr(t.blockLen)},exists:function(t,e=!0){if(t.destroyed)throw new Error("Hash instance has been destroyed");if(e&&t.finished)throw new Error("Hash#digest() has already been called")},output:function(t,e){Ar(t);const r=e.outputLen;if(t.length<r)throw new Error(`digestInto() expects output buffer of length at least ${r}`)}};var Ur=Ir;
/*! noble-hashes - MIT License (c) 2022 Paul Miller (paulmillr.com) */const Sr=t=>t instanceof Uint8Array,Lr=t=>new DataView(t.buffer,t.byteOffset,t.byteLength),Hr=(t,e)=>t<<32-e|t>>>e;if(!(68===new Uint8Array(new Uint32Array([287454020]).buffer)[0]))throw new Error("Non little-endian hardware is not supported");function _r(t){if("string"==typeof t&&(t=function(t){if("string"!=typeof t)throw new Error("utf8ToBytes expected string, got "+typeof t);return new Uint8Array((new TextEncoder).encode(t))}(t)),!Sr(t))throw new Error("expected Uint8Array, got "+typeof t);return t}Array.from({length:256},((t,e)=>e.toString(16).padStart(2,"0")));class $r{clone(){return this._cloneInto()}}function Or(t){const e=e=>t().update(_r(e)).digest(),r=t();return e.outputLen=r.outputLen,e.blockLen=r.blockLen,e.create=()=>t(),e}class Tr extends $r{constructor(t,e,r,n){super(),this.blockLen=t,this.outputLen=e,this.padOffset=r,this.isLE=n,this.finished=!1,this.length=0,this.pos=0,this.destroyed=!1,this.buffer=new Uint8Array(t),this.view=Lr(this.buffer)}update(t){Ur.exists(this);const{view:e,buffer:r,blockLen:n}=this,i=(t=_r(t)).length;for(let o=0;o<i;){const s=Math.min(n-this.pos,i-o);if(s!==n)r.set(t.subarray(o,o+s),this.pos),this.pos+=s,o+=s,this.pos===n&&(this.process(e,0),this.pos=0);else{const e=Lr(t);for(;n<=i-o;o+=n)this.process(e,o)}}return this.length+=t.length,this.roundClean(),this}digestInto(t){Ur.exists(this),Ur.output(t,this),this.finished=!0;const{buffer:e,view:r,blockLen:n,isLE:i}=this;let{pos:o}=this;e[o++]=128,this.buffer.subarray(o).fill(0),this.padOffset>n-o&&(this.process(r,0),o=0);for(let t=o;t<n;t++)e[t]=0;!function(t,e,r,n){if("function"==typeof t.setBigUint64)return t.setBigUint64(e,r,n);const i=BigInt(32),o=BigInt(4294967295),s=Number(r>>i&o),f=Number(r&o),a=n?4:0,h=n?0:4;t.setUint32(e+a,s,n),t.setUint32(e+h,f,n)}(r,n-8,BigInt(8*this.length),i),this.process(r,0);const s=Lr(t),f=this.outputLen;if(f%4)throw new Error("_sha2: outputLen should be aligned to 32bit");const a=f/4,h=this.get();if(a>h.length)throw new Error("_sha2: outputLen bigger than state");for(let t=0;t<a;t++)s.setUint32(4*t,h[t],i)}digest(){const{buffer:t,outputLen:e}=this;this.digestInto(t);const r=t.slice(0,e);return this.destroy(),r}_cloneInto(t){t||(t=new this.constructor),t.set(...this.get());const{blockLen:e,buffer:r,length:n,finished:i,destroyed:o,pos:s}=this;return t.length=n,t.pos=s,t.finished=i,t.destroyed=o,n%e&&t.buffer.set(r),t}}const Nr=(t,e,r)=>t&e^t&r^e&r,Rr=new Uint32Array([1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298]),Cr=new Uint32Array([1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225]),kr=new Uint32Array(64);class Dr extends Tr{constructor(){super(64,32,8,!1),this.A=0|Cr[0],this.B=0|Cr[1],this.C=0|Cr[2],this.D=0|Cr[3],this.E=0|Cr[4],this.F=0|Cr[5],this.G=0|Cr[6],this.H=0|Cr[7]}get(){const{A:t,B:e,C:r,D:n,E:i,F:o,G:s,H:f}=this;return[t,e,r,n,i,o,s,f]}set(t,e,r,n,i,o,s,f){this.A=0|t,this.B=0|e,this.C=0|r,this.D=0|n,this.E=0|i,this.F=0|o,this.G=0|s,this.H=0|f}process(t,e){for(let r=0;r<16;r++,e+=4)kr[r]=t.getUint32(e,!1);for(let t=16;t<64;t++){const e=kr[t-15],r=kr[t-2],n=Hr(e,7)^Hr(e,18)^e>>>3,i=Hr(r,17)^Hr(r,19)^r>>>10;kr[t]=i+kr[t-7]+n+kr[t-16]|0}let{A:r,B:n,C:i,D:o,E:s,F:f,G:a,H:h}=this;for(let t=0;t<64;t++){const e=h+(Hr(s,6)^Hr(s,11)^Hr(s,25))+((c=s)&f^~c&a)+Rr[t]+kr[t]|0,u=(Hr(r,2)^Hr(r,13)^Hr(r,22))+Nr(r,n,i)|0;h=a,a=f,f=s,s=o+e|0,o=i,i=n,n=r,r=e+u|0}var c;r=r+this.A|0,n=n+this.B|0,i=i+this.C|0,o=o+this.D|0,s=s+this.E|0,f=f+this.F|0,a=a+this.G|0,h=h+this.H|0,this.set(r,n,i,o,s,f,a,h)}roundClean(){kr.fill(0)}destroy(){this.set(0,0,0,0,0,0,0,0),this.buffer.fill(0)}}class Fr extends Dr{constructor(){super(),this.A=-1056596264,this.B=914150663,this.C=812702999,this.D=-150054599,this.E=-4191439,this.F=1750603025,this.G=1694076839,this.H=-1090891868,this.outputLen=28}}const Pr=Or((()=>new Dr));Or((()=>new Fr));const qr=BigInt(2**32-1),zr=BigInt(32);function jr(t,e=!1){return e?{h:Number(t&qr),l:Number(t>>zr&qr)}:{h:0|Number(t>>zr&qr),l:0|Number(t&qr)}}var Vr={fromBig:jr,split:function(t,e=!1){let r=new Uint32Array(t.length),n=new Uint32Array(t.length);for(let i=0;i<t.length;i++){const{h:o,l:s}=jr(t[i],e);[r[i],n[i]]=[o,s]}return[r,n]},toBig:(t,e)=>BigInt(t>>>0)<<zr|BigInt(e>>>0),shrSH:(t,e,r)=>t>>>r,shrSL:(t,e,r)=>t<<32-r|e>>>r,rotrSH:(t,e,r)=>t>>>r|e<<32-r,rotrSL:(t,e,r)=>t<<32-r|e>>>r,rotrBH:(t,e,r)=>t<<64-r|e>>>r-32,rotrBL:(t,e,r)=>t>>>r-32|e<<64-r,rotr32H:(t,e)=>e,rotr32L:(t,e)=>t,rotlSH:(t,e,r)=>t<<r|e>>>32-r,rotlSL:(t,e,r)=>e<<r|t>>>32-r,rotlBH:(t,e,r)=>e<<r-32|t>>>64-r,rotlBL:(t,e,r)=>t<<r-32|e>>>64-r,add:function(t,e,r,n){const i=(e>>>0)+(n>>>0);return{h:t+r+(i/2**32|0)|0,l:0|i}},add3L:(t,e,r)=>(t>>>0)+(e>>>0)+(r>>>0),add3H:(t,e,r,n)=>e+r+n+(t/2**32|0)|0,add4L:(t,e,r,n)=>(t>>>0)+(e>>>0)+(r>>>0)+(n>>>0),add4H:(t,e,r,n,i)=>e+r+n+i+(t/2**32|0)|0,add5H:(t,e,r,n,i,o)=>e+r+n+i+o+(t/2**32|0)|0,add5L:(t,e,r,n,i)=>(t>>>0)+(e>>>0)+(r>>>0)+(n>>>0)+(i>>>0)};const[Gr,Wr]=Vr.split(["0x428a2f98d728ae22","0x7137449123ef65cd","0xb5c0fbcfec4d3b2f","0xe9b5dba58189dbbc","0x3956c25bf348b538","0x59f111f1b605d019","0x923f82a4af194f9b","0xab1c5ed5da6d8118","0xd807aa98a3030242","0x12835b0145706fbe","0x243185be4ee4b28c","0x550c7dc3d5ffb4e2","0x72be5d74f27b896f","0x80deb1fe3b1696b1","0x9bdc06a725c71235","0xc19bf174cf692694","0xe49b69c19ef14ad2","0xefbe4786384f25e3","0x0fc19dc68b8cd5b5","0x240ca1cc77ac9c65","0x2de92c6f592b0275","0x4a7484aa6ea6e483","0x5cb0a9dcbd41fbd4","0x76f988da831153b5","0x983e5152ee66dfab","0xa831c66d2db43210","0xb00327c898fb213f","0xbf597fc7beef0ee4","0xc6e00bf33da88fc2","0xd5a79147930aa725","0x06ca6351e003826f","0x142929670a0e6e70","0x27b70a8546d22ffc","0x2e1b21385c26c926","0x4d2c6dfc5ac42aed","0x53380d139d95b3df","0x650a73548baf63de","0x766a0abb3c77b2a8","0x81c2c92e47edaee6","0x92722c851482353b","0xa2bfe8a14cf10364","0xa81a664bbc423001","0xc24b8b70d0f89791","0xc76c51a30654be30","0xd192e819d6ef5218","0xd69906245565a910","0xf40e35855771202a","0x106aa07032bbd1b8","0x19a4c116b8d2d0c8","0x1e376c085141ab53","0x2748774cdf8eeb99","0x34b0bcb5e19b48a8","0x391c0cb3c5c95a63","0x4ed8aa4ae3418acb","0x5b9cca4f7763e373","0x682e6ff3d6b2b8a3","0x748f82ee5defb2fc","0x78a5636f43172f60","0x84c87814a1f0ab72","0x8cc702081a6439ec","0x90befffa23631e28","0xa4506cebde82bde9","0xbef9a3f7b2c67915","0xc67178f2e372532b","0xca273eceea26619c","0xd186b8c721c0c207","0xeada7dd6cde0eb1e","0xf57d4f7fee6ed178","0x06f067aa72176fba","0x0a637dc5a2c898a6","0x113f9804bef90dae","0x1b710b35131c471b","0x28db77f523047d84","0x32caab7b40c72493","0x3c9ebe0a15c9bebc","0x431d67c49c100d4c","0x4cc5d4becb3e42b6","0x597f299cfc657e2a","0x5fcb6fab3ad6faec","0x6c44198c4a475817"].map((t=>BigInt(t)))),Zr=new Uint32Array(80),Yr=new Uint32Array(80);class Kr extends Tr{constructor(){super(128,64,16,!1),this.Ah=1779033703,this.Al=-205731576,this.Bh=-1150833019,this.Bl=-2067093701,this.Ch=1013904242,this.Cl=-23791573,this.Dh=-1521486534,this.Dl=1595750129,this.Eh=1359893119,this.El=-1377402159,this.Fh=-1694144372,this.Fl=725511199,this.Gh=528734635,this.Gl=-79577749,this.Hh=1541459225,this.Hl=327033209}get(){const{Ah:t,Al:e,Bh:r,Bl:n,Ch:i,Cl:o,Dh:s,Dl:f,Eh:a,El:h,Fh:c,Fl:u,Gh:d,Gl:l,Hh:g,Hl:p}=this;return[t,e,r,n,i,o,s,f,a,h,c,u,d,l,g,p]}set(t,e,r,n,i,o,s,f,a,h,c,u,d,l,g,p){this.Ah=0|t,this.Al=0|e,this.Bh=0|r,this.Bl=0|n,this.Ch=0|i,this.Cl=0|o,this.Dh=0|s,this.Dl=0|f,this.Eh=0|a,this.El=0|h,this.Fh=0|c,this.Fl=0|u,this.Gh=0|d,this.Gl=0|l,this.Hh=0|g,this.Hl=0|p}process(t,e){for(let r=0;r<16;r++,e+=4)Zr[r]=t.getUint32(e),Yr[r]=t.getUint32(e+=4);for(let t=16;t<80;t++){const e=0|Zr[t-15],r=0|Yr[t-15],n=Vr.rotrSH(e,r,1)^Vr.rotrSH(e,r,8)^Vr.shrSH(e,r,7),i=Vr.rotrSL(e,r,1)^Vr.rotrSL(e,r,8)^Vr.shrSL(e,r,7),o=0|Zr[t-2],s=0|Yr[t-2],f=Vr.rotrSH(o,s,19)^Vr.rotrBH(o,s,61)^Vr.shrSH(o,s,6),a=Vr.rotrSL(o,s,19)^Vr.rotrBL(o,s,61)^Vr.shrSL(o,s,6),h=Vr.add4L(i,a,Yr[t-7],Yr[t-16]),c=Vr.add4H(h,n,f,Zr[t-7],Zr[t-16]);Zr[t]=0|c,Yr[t]=0|h}let{Ah:r,Al:n,Bh:i,Bl:o,Ch:s,Cl:f,Dh:a,Dl:h,Eh:c,El:u,Fh:d,Fl:l,Gh:g,Gl:p,Hh:w,Hl:y}=this;for(let t=0;t<80;t++){const e=Vr.rotrSH(c,u,14)^Vr.rotrSH(c,u,18)^Vr.rotrBH(c,u,41),b=Vr.rotrSL(c,u,14)^Vr.rotrSL(c,u,18)^Vr.rotrBL(c,u,41),m=c&d^~c&g,x=u&l^~u&p,E=Vr.add5L(y,b,x,Wr[t],Yr[t]),B=Vr.add5H(E,w,e,m,Gr[t],Zr[t]),v=0|E,A=Vr.rotrSH(r,n,28)^Vr.rotrBH(r,n,34)^Vr.rotrBH(r,n,39),I=Vr.rotrSL(r,n,28)^Vr.rotrBL(r,n,34)^Vr.rotrBL(r,n,39),U=r&i^r&s^i&s,S=n&o^n&f^o&f;w=0|g,y=0|p,g=0|d,p=0|l,d=0|c,l=0|u,({h:c,l:u}=Vr.add(0|a,0|h,0|B,0|v)),a=0|s,h=0|f,s=0|i,f=0|o,i=0|r,o=0|n;const L=Vr.add3L(v,I,S);r=Vr.add3H(L,B,A,U),n=0|L}({h:r,l:n}=Vr.add(0|this.Ah,0|this.Al,0|r,0|n)),({h:i,l:o}=Vr.add(0|this.Bh,0|this.Bl,0|i,0|o)),({h:s,l:f}=Vr.add(0|this.Ch,0|this.Cl,0|s,0|f)),({h:a,l:h}=Vr.add(0|this.Dh,0|this.Dl,0|a,0|h)),({h:c,l:u}=Vr.add(0|this.Eh,0|this.El,0|c,0|u)),({h:d,l:l}=Vr.add(0|this.Fh,0|this.Fl,0|d,0|l)),({h:g,l:p}=Vr.add(0|this.Gh,0|this.Gl,0|g,0|p)),({h:w,l:y}=Vr.add(0|this.Hh,0|this.Hl,0|w,0|y)),this.set(r,n,i,o,s,f,a,h,c,u,d,l,g,p,w,y)}roundClean(){Zr.fill(0),Yr.fill(0)}destroy(){this.buffer.fill(0),this.set(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)}}class Mr extends Kr{constructor(){super(),this.Ah=-1942145080,this.Al=424955298,this.Bh=1944164710,this.Bl=-1982016298,this.Ch=502970286,this.Cl=855612546,this.Dh=1738396948,this.Dl=1479516111,this.Eh=258812777,this.El=2077511080,this.Fh=2011393907,this.Fl=79989058,this.Gh=1067287976,this.Gl=1780299464,this.Hh=286451373,this.Hl=-1848208735,this.outputLen=28}}class Jr extends Kr{constructor(){super(),this.Ah=573645204,this.Al=-64227540,this.Bh=-1621794909,this.Bl=-934517566,this.Ch=596883563,this.Cl=1867755857,this.Dh=-1774684391,this.Dl=1497426621,this.Eh=-1775747358,this.El=-1467023389,this.Fh=-1101128155,this.Fl=1401305490,this.Gh=721525244,this.Gl=746961066,this.Hh=246885852,this.Hl=-2117784414,this.outputLen=32}}class Xr extends Kr{constructor(){super(),this.Ah=-876896931,this.Al=-1056596264,this.Bh=1654270250,this.Bl=914150663,this.Ch=-1856437926,this.Cl=812702999,this.Dh=355462360,this.Dl=-150054599,this.Eh=1731405415,this.El=-4191439,this.Fh=-1900787065,this.Fl=1750603025,this.Gh=-619958771,this.Gl=1694076839,this.Hh=1203062813,this.Hl=-1090891868,this.outputLen=48}}const Qr=Or((()=>new Kr));Or((()=>new Mr)),Or((()=>new Jr)),Or((()=>new Xr));const tn=new Uint8Array([7,4,13,1,10,6,15,3,12,0,9,5,2,14,11,8]),en=Uint8Array.from({length:16},((t,e)=>e)),rn=en.map((t=>(9*t+5)%16));let nn=[en],on=[rn];for(let t=0;t<4;t++)for(let e of[nn,on])e.push(e[t].map((t=>tn[t])));const sn=[[11,14,15,12,5,8,7,9,11,13,14,15,6,7,9,8],[12,13,11,15,6,9,9,7,12,15,11,13,7,8,7,7],[13,15,14,11,7,7,6,8,13,14,13,12,5,5,6,9],[14,11,12,14,8,6,5,5,15,12,15,14,9,9,8,6],[15,12,13,13,9,5,8,6,14,11,12,11,8,6,5,5]].map((t=>new Uint8Array(t))),fn=nn.map(((t,e)=>t.map((t=>sn[e][t])))),an=on.map(((t,e)=>t.map((t=>sn[e][t])))),hn=new Uint32Array([0,1518500249,1859775393,2400959708,2840853838]),cn=new Uint32Array([1352829926,1548603684,1836072691,2053994217,0]),un=(t,e)=>t<<e|t>>>32-e;function dn(t,e,r,n){return 0===t?e^r^n:1===t?e&r|~e&n:2===t?(e|~r)^n:3===t?e&n|r&~n:e^(r|~n)}const ln=new Uint32Array(16);class gn extends Tr{constructor(){super(64,20,8,!0),this.h0=1732584193,this.h1=-271733879,this.h2=-1732584194,this.h3=271733878,this.h4=-1009589776}get(){const{h0:t,h1:e,h2:r,h3:n,h4:i}=this;return[t,e,r,n,i]}set(t,e,r,n,i){this.h0=0|t,this.h1=0|e,this.h2=0|r,this.h3=0|n,this.h4=0|i}process(t,e){for(let r=0;r<16;r++,e+=4)ln[r]=t.getUint32(e,!0);let r=0|this.h0,n=r,i=0|this.h1,o=i,s=0|this.h2,f=s,a=0|this.h3,h=a,c=0|this.h4,u=c;for(let t=0;t<5;t++){const e=4-t,d=hn[t],l=cn[t],g=nn[t],p=on[t],w=fn[t],y=an[t];for(let e=0;e<16;e++){const n=un(r+dn(t,i,s,a)+ln[g[e]]+d,w[e])+c|0;r=c,c=a,a=0|un(s,10),s=i,i=n}for(let t=0;t<16;t++){const r=un(n+dn(e,o,f,h)+ln[p[t]]+l,y[t])+u|0;n=u,u=h,h=0|un(f,10),f=o,o=r}}this.set(this.h1+s+h|0,this.h2+a+u|0,this.h3+c+n|0,this.h4+r+o|0,this.h0+i+f|0)}roundClean(){ln.fill(0)}destroy(){this.destroyed=!0,this.buffer.fill(0),this.set(0,0,0,0,0)}}const pn=Or((()=>new gn));class wn extends $r{constructor(t,e){super(),this.finished=!1,this.destroyed=!1,Ur.hash(t);const r=_r(e);if(this.iHash=t.create(),"function"!=typeof this.iHash.update)throw new Error("Expected instance of class which extends utils.Hash");this.blockLen=this.iHash.blockLen,this.outputLen=this.iHash.outputLen;const n=this.blockLen,i=new Uint8Array(n);i.set(r.length>n?t.create().update(r).digest():r);for(let t=0;t<i.length;t++)i[t]^=54;this.iHash.update(i),this.oHash=t.create();for(let t=0;t<i.length;t++)i[t]^=106;this.oHash.update(i),i.fill(0)}update(t){return Ur.exists(this),this.iHash.update(t),this}digestInto(t){Ur.exists(this),Ur.bytes(t,this.outputLen),this.finished=!0,this.iHash.digestInto(t),this.oHash.update(t),this.oHash.digestInto(t),this.destroy()}digest(){const t=new Uint8Array(this.oHash.outputLen);return this.digestInto(t),t}_cloneInto(t){t||(t=Object.create(Object.getPrototypeOf(this),{}));const{oHash:e,iHash:r,finished:n,destroyed:i,blockLen:o,outputLen:s}=this;return t.finished=n,t.destroyed=i,t.blockLen=o,t.outputLen=s,t.oHash=e._cloneInto(t.oHash),t.iHash=r._cloneInto(t.iHash),t}destroy(){this.destroyed=!0,this.oHash.destroy(),this.iHash.destroy()}}const yn=(t,e,r)=>new wn(t,e).update(r).digest();function bn(t){const e=ar.bytes(t);return ar.raw(Pr(e))}function mn(t){const e=ar.bytes(t);return ar.raw(Qr(e))}function xn(t){const e=ar.bytes(t);return ar.raw(Qr(e))}function En(t){const e=ar.bytes(t);return ar.raw(Pr(Pr(e)))}function Bn(t){const e=ar.bytes(t);return ar.raw(pn(Pr(e)))}function vn(t,e){const r=ar.bytes(t),n=ar.bytes(e);return ar.raw(yn(Pr,r,n))}function An(t,e){const r=ar.bytes(t),n=ar.bytes(e);return ar.raw(yn(Qr,r,n))}function In(t){const e=ar.str(t).digest;return ar.join([e,e])}function Un(t,...e){const r=In(t);return ar.join([r,...e]).digest}yn.create=(t,e)=>new wn(t,e);const Sn=Lt.CURVE,Ln=Sn.n,Hn=Sn.p,_n={x:Sn.Gx,y:Sn.Gy},$n=BigInt(0),On=BigInt(1),Tn=BigInt(2),Nn=BigInt(3),Rn=BigInt(4),Cn={N:Ln,P:Hn,G:_n,_0n:$n,_1n:On,_2n:Tn,_3n:Nn,_4n:Rn},kn=it(Ln,32,!0),Dn=t=>M(t,Ln);var Fn=Object.freeze({__proto__:null,CONST:Cn,curve:Sn,ecc:kn,in_field:t=>"bigint"==typeof t&&$n<t&&t<Ln,invert:Q,mod:M,modN:Dn,modP:t=>M(t,Hn),mod_bytes:function(t){const e=ar.bytes(t).big;return ar.big(Dn(e),32)},on_curve:t=>"bigint"==typeof t&&$n<t&&t<Hn,pow:J,pow2:X,powN:(t,e)=>J(t,e,Ln)});function Pn(t){return ar.random(t)}function qn(t){const e=ar.bytes(t);if(32===e.length)return e;if(33===e.length)return e.slice(1,33);throw new TypeError(`Invalid key length: ${e.length}`)}function zn(t,e=!1){const r=ar.bytes(t);if(32===r.length)return r.prepend(2);if(33===r.length)return e&&(r[0]=2),r;throw new TypeError(`Invalid key size: ${r.length}`)}var jn=Object.freeze({__proto__:null,increment_buffer:function(t){let e=t.length-1;for(;e>=0;e--)if(t[e]<255)return t.set([t[e]+1],e),t;throw TypeError("Unable to increment buffer: "+t.toString())},normalize_x:zn,parse_extended_key:function(t){const e=ar.b58chk(t).stream,r={prefix:e.read(4).num,depth:e.read(1).num,fprint:e.read(4).num,index:e.read(4).num,code:e.read(32).hex,type:e.read(1).num,key:e.read(32).hex};if(e.size>0)throw new TypeError("Unparsed data remaining in buffer!");return r},parse_x:qn,random:Pn});const{_1n:Vn}=Cn,Gn=Lt.ProjectivePoint,Wn=Gn;function Zn(t){return new Gn(t.x,t.y,Vn).hasEvenY()}function Yn(t){return"object"==typeof t&&"bigint"==typeof t.x&&"bigint"==typeof t.y}function Kn(t){if(!Yn(t))return!1;const e=new Gn(t.x,t.y,Vn);try{return e.assertValidity(),!0}catch{return!1}}var Mn=Object.freeze({__proto__:null,Noble:Wn,add:function(t,e){if(null===t)return e;if(null===e)return t;const r=new Gn(t.x,t.y,Vn),n=new Gn(e.x,e.y,Vn);try{const t=r.add(n);return t.assertValidity(),{x:t.x,y:t.y}}catch{return null}},eq:function(t,e){return null===t&&null===e||null!==t&&null!==e&&(t.x===e.x&&t.y===e.y)},gen:function(t){const e=ar.bytes(t),r=Gn.BASE.multiply(e.big);return r.assertValidity(),{x:r.x,y:r.y}},is_even:Zn,is_point:Yn,is_valid:Kn,lift_x:function(t,e=!1){const r=zn(t,e),n=Gn.fromHex(r.hex);return n.assertValidity(),{x:n.x,y:n.y}},mul:function(t,e){if(null===t)return null;try{const r=ar.bytes(e),n=new Gn(t.x,t.y,Vn).multiply(r.big);return n.assertValidity(),{x:n.x,y:n.y}}catch{return null}},negate:function(t){const e=new Gn(t.x,t.y,Vn);try{const t=e.negate();return t.assertValidity(),{x:t.x,y:t.y}}catch{return null}},sub:function(t,e){if(null===t)return e;if(null===e)return t;const r=new Gn(t.x,t.y,Vn),n=new Gn(e.x,e.y,Vn);try{const t=r.subtract(n);return t.assertValidity(),{x:t.x,y:t.y}}catch{return null}},to_bytes:function(t){const e=ar.big(t.x,32),r=Zn(t)?2:3;return ar.join([r,e])}});const{N:Jn,P:Xn,_0n:Qn}=Cn;function ti(t,e=!1){if(e)throw new Error(t);return!1}function ei(t,e,r){const n=ar.bytes(t);return n.length===e||ti(`Invalid byte size: ${n.hex} !== ${e}`,r)}function ri(t,e){return"bigint"==typeof t&&Qn<t&&t<Xn||ti("x value is not on the curve!",e),!0}function ni(t,e){return"bigint"==typeof t&&Qn<t&&t<Jn||ti("x value is not in the field!",e),!0}function ii(t,e){if(void 0===e){if(!t.startsWith("m"))throw new Error("You need to specify a chain-code for a non-root path.")}else if(32!==ar.bytes(e).length)throw new Error("Chain code must be 32 bytes!")}function oi(t){if(null===t.match(/^(m)?(\/)?(\w+'?\/)*\w+'?$/))throw new Error("Provided path string is invalid: "+t)}function si(t){if(t>2147483648)throw new TypeError("Index value must not exceed 31 bits.")}function fi(t,e){if(t&&!e)throw new Error("Cannot derive hardedened paths when is_private is false!")}var ai=Object.freeze({__proto__:null,exists:function(t){if(void 0===t)throw new TypeError("Input is undefined!")},fail:ti,in_field:ni,min_value:function(t,e){const r=ar.bytes(t).big;if(r<e)throw new TypeError(`Bytes integer value is too low: ${r} < ${e}`)},on_curve:ri,size:ei,valid_chain:ii,valid_derive_state:fi,valid_hash:function(t){if(null===t.match(/^[0-9a-fA-F]{64}$/))throw new Error("Provided hash string is invalid: "+t)},valid_index:si,valid_path:oi,valid_point:function(t){if(!Kn(t))throw new TypeError("Point is invalid!")},valid_pubkey:function(t){if(33!==ar.bytes(t).length)throw new TypeError("Index value must not exceed 31 bits.")}});const hi=Lt.ProjectivePoint;class ci extends Uint8Array{static{this.N=Lt.CURVE.n}static mod(t){return new ci(t)}static is_valid(t,e){return ni(ar.bytes(t,32).big,e)}constructor(t){let e=function(t){if(t instanceof ci)return t.big;if(t instanceof ui)return t.x.big;if(t instanceof Uint8Array)return ar.raw(t).big;if("string"==typeof t)return ar.hex(t).big;if("number"==typeof t)return ar.num(t).big;if("bigint"==typeof t)return BigInt(t);throw TypeError("Invalid input type:"+typeof t)}(t);e=Dn(e),ci.is_valid(e,!0),super(ar.big(e,32),32)}get buff(){return new ar(this)}get raw(){return this.buff.raw}get big(){return this.buff.big}get hex(){return this.buff.hex}get point(){return this.generate()}get hasOddY(){return this.point.hasOddY}get negated(){return this.hasOddY?this.negate():this}gt(t){return new ci(t).big>this.big}lt(t){return new ci(t).big<this.big}eq(t){return new ci(t).big===this.big}ne(t){return new ci(t).big!==this.big}add(t){const e=ci.mod(t),r=kn.add(this.big,e.big);return new ci(r)}sub(t){const e=ci.mod(t),r=kn.sub(this.big,e.big);return new ci(r)}mul(t){const e=ci.mod(t),r=kn.mul(this.big,e.big);return new ci(r)}pow(t){const e=ci.mod(t),r=kn.pow(this.big,e.big);return new ci(r)}div(t){const e=ci.mod(t),r=kn.div(this.big,e.big);return new ci(r)}negate(){return new ci(ci.N-this.big)}generate(){const t=Lt.ProjectivePoint.BASE.multiply(this.big);return ui.import(t)}}class ui{static{this.P=Cn.P}static{this.G=new ui(Cn.G.x,Cn.G.y)}static{this.curve=Lt.CURVE}static{this.base=Lt.ProjectivePoint.BASE}static from_x(t){let e=function(t){if(t instanceof ci)return t.point.buff;if(t instanceof ui)return t.buff;if(t instanceof Uint8Array||"string"==typeof t)return ar.bytes(t);if("number"==typeof t||"bigint"==typeof t)return ar.bytes(t,32);throw new TypeError("Unknown type: "+typeof t)}(t);32===e.length&&(e=e.prepend(2)),ei(e,33);const r=hi.fromHex(e.hex);return r.assertValidity(),new ui(r.x,r.y)}static generate(t){const e=ci.mod(t),r=ui.base.multiply(e.big);return ui.import(r)}static{this.mul=ui.generate}static import(t){const e=t instanceof ui?{x:t.x.big,y:t.y.big}:{x:t.x,y:t.y};return new ui(e.x,e.y)}constructor(t,e){this._p=new hi(t,e,1n),this.p.assertValidity()}get p(){return this._p}get x(){return ar.big(this.p.x,32)}get y(){return ar.big(this.p.y,32)}get buff(){return ar.raw(this.p.toRawBytes(!0))}get raw(){return this.buff.raw}get hex(){return this.buff.hex}get hasEvenY(){return this.p.hasEvenY()}get hasOddY(){return!this.p.hasEvenY()}eq(t){const e=t instanceof ui?t:ui.from_x(t);return this.x.big===e.x.big&&this.y.big===e.y.big}add(t){return t instanceof ui?ui.import(this.p.add(t.p)):ui.import(this.p.add(ui.generate(t).p))}sub(t){return t instanceof ui?ui.import(this.p.subtract(t.p)):ui.import(this.p.subtract(ui.generate(t).p))}mul(t){return t instanceof ui?ui.import(this.p.multiply(t.x.big)):ui.import(this.p.multiply(ci.mod(t).big))}negate(){return ui.import(this.p.negate())}}function di(t,e=!1){const r=ci.mod(t);return e?r.negated.buff:r.buff}function li(t,e=!1){const r=ci.mod(t).point;return e?r.x:r.buff}function gi(t,e,r){const n=di(t,r);return[n,li(n,e)]}var pi=Object.freeze({__proto__:null,gen_keypair:function(t,e){return gi(Pn(32),t,e)},gen_seckey:function(t){return di(Pn(32),t)},get_keypair:gi,get_pubkey:li,get_seckey:di,is_even_pub:function(t){const e=ar.bytes(t);switch(!0){case 32===e.length:case 33===e.length&&2===e[0]:return!0;case 33===e.length&&3===e[0]:return!1;default:throw new TypeError(`Invalid public key: ${e.hex}`)}}});const wi=/^[0-9]{0,10}$/,yi=/^[0-9a-zA-Z_&?=]{64}$/;function bi(t,e){const r=An(t,e);return[r.slice(0,32),r.slice(32)]}const mi={aux:ar.random(32),throws:!1,xonly:!0},xi={xonly:!1,even_y:!1,tag:"ecdh/shared"};function Ei(t={}){return{...mi,...t}}function Bi(t={}){return{...xi,...t}}function vi(t,e){const r=ui.from_x(e),n=ci.mod(t);return r.mul(n).buff}function Ai(t,e,r){const n=Bi(r),i=di(t,n.even_y),o=li(i,n.xonly),s=In(n.tag),f=ar.bytes(e),a=vi(i,f),h=[o.hex,f.hex];if(h.sort(),void 0!==n.aux){const t=ar.bytes(n.aux);h.push(t.hex)}return An(a,ar.join([s,...h]))}var Ii=Object.freeze({__proto__:null,get_shared_code:Ai,get_shared_key:vi});const{_0n:Ui}=Cn;var Si=Object.freeze({__proto__:null,recover:function(t,e,r,n){const i=ar.bytes(t),o=ar.bytes(e),s=ar.bytes(r),f=Un("BIP0340/nonce",Ai(n,r,{tag:"ecdh/recovery"}),e),a=Un("BIP0340/challenge",i.slice(0,32),qn(s),o),h=new ci(a),c=new ci(f).negated;return new ci(i.slice(32,64)).sub(c).div(h).buff},sign:function(t,e,r){const n=Ei(r),{adaptor:i,tweak:o,xonly:s}=n,f=ar.bytes(t);let a=ci.mod(e);void 0!==o&&(s&&(a=a.negated),a=a.add(o));const h=a.point,c=s?a.negated.big:a.big,u=function(t,e,r,n){const{aux:i,nonce:o,recovery:s}=Ei(n);let f;if(void 0!==o)f=ar.bytes(o);else if(void 0!==s)f=Ai(t,s,{tag:"ecdh/recovery"});else{const r=Un("BIP0340/aux",i),n=ar.bytes(t).big^r.big;f=ar.join([n,e])}return Un("BIP0340/nonce",f,ar.bytes(r))}(ar.big(c,32),h.x,f,n);let d=ci.mod(u);void 0!==i&&(s&&(d=d.negated),d=d.add(i));const l=d.point,g=s?d.negated.big:d.big,p=Un("BIP0340/challenge",l.x.raw,h.x.raw,f),w=ci.mod(p),y=ci.mod(g+w.big*c),b=s?l.x.raw:l.raw;return ar.join([b,y.raw])},verify:function(t,e,r,n){const{throws:i}=Ei(n),o=ar.bytes(e),s=ar.bytes(t);if(s.length<64)return ti("Signature length is too small: "+String(s.length),i);ei(r,32);const f=ui.from_x(r),a=s.subarray(0,32),h=ui.from_x(a),c=s.subarray(32,64),u=ci.mod(c).point,d=Un("BIP0340/challenge",h.x,f.x,o),l=ci.mod(d),g=f.mul(l.big),p=u.sub(g);return h.hasOddY?ti("Signature R value has odd Y coordinate!",i):h.x.big===Ui?ti("Signature R value is infinite!",i):h.x.big!==p.x.big?ti(`Signature is invalid! R: ${h.x.hex} r:${p.x.hex}`,i):h.x.big===p.x.big}});const Li={secp:Lt,schnorr:Vt},Hi={...pi,...Si,derive:function(t,e,r,n=!1){oi(t);const i=t.startsWith("m");ii(t,r);let o=void 0!==r?ar.bytes(r):ar.str("Bitcoin seed"),s=ar.bytes(e);if(i){const t=bi(o,s);s=ar.raw(t[0]),o=ar.raw(t[1]),n=!0}n?ei(s,32,!0):(33===s.length&&(s=s.slice(1)),ei(s,33));const f=function(t){const e=[];let r=t.split("/");"m"!==r[0]&&""!==r[0]||(r=r.slice(1));for(let t of r){let r=!1;if("'"===t.slice(-1)&&(r=!0,t=t.slice(0,-1)),null!==t.match(wi)){let n=parseInt(t,10);si(n),r&&(n+=2147483648),e.push([ar.num(n,4),r])}else{if(null===t.match(yi))throw new Error("Invalid path segment:"+t);{let n=ar.str(t);r&&(n=n.prepend(128)),e.push([n.digest,r])}}}return e}(t);for(const t of f){const[e,r]=t;fi(r,n);const i=r?ar.join([0,s,e]):ar.join([li(s),e]),[f,a]=bi(o,i);o=ar.raw(a),n?(s=ci.mod(s).add(f).buff,ni(s.big,!0)):(s=ui.from_x(s).add(f).buff,ri(s.slice(1).big))}return[s,o]},parse_x:qn,normalize_x:zn};return t.Field=ci,t.Point=ui,t.assert=ai,t.code_config=Bi,t.digest=Un,t.ecc=Hi,t.ecdh=Ii,t.hash=function(t,e="sha256"){switch(e){case"sha256":return bn(t);case"sha512":return mn(t);case"hash256":return En(t);case"ripe160":return xn(t);case"hash160":return Bn(t);default:throw new Error("Unrecognized format:"+String(e))}},t.hash160=Bn,t.hash256=En,t.hmac=function(t,e,r="hmac256"){switch(r){case"hmac256":return vn(t,e);case"hmac512":return An(t,e);default:throw new Error("Unrecognized format:"+String(r))}},t.hmac256=vn,t.hmac512=An,t.math=Fn,t.noble=Li,t.point=Mn,t.ripe160=xn,t.sha256=bn,t.sha512=mn,t.sign_config=Ei,t.taghash=In,t.util=jn,t}({});
//# sourceMappingURL=browser.js.map
